AppTitle "ZEITLOS - Das Uhrzeit-Tool"
Graphics3D 400,400,24,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

;the clock images
Global Clock_Menu = LoadImage("Clock.png")
MaskImage Clock_Menu,255,255,255
Global Clockhand1 = LoadImage("Clockhand1.png")
MaskImage Clockhand1,255,0,255
Global Clockhand2 = LoadImage("Clockhand2.png")
MaskImage Clockhand2,255,0,255
Global Clockhand3 = LoadImage("Clockhand3.png")
MaskImage Clockhand3,255,0,255
Global Clockhand4 = LoadImage("Clockhand4.png")
MaskImage Clockhand4,255,0,255
Global Clockhand5 = LoadImage("Clockhand5.png")
MaskImage Clockhand5,255,0,255
Global Clockhand6 = LoadImage("Clockhand6.png")
MaskImage Clockhand6,255,0,255
Global Clockhand7 = LoadImage("Clockhand7.png")
MaskImage Clockhand7,255,0,255
Global Clockhand8 = LoadImage("Clockhand8.png")
MaskImage Clockhand8,255,0,255

;3D clocks
Global Clock3D = LoadMesh("Clock3d.3ds")
Global Hand_hour = LoadMesh("Hand_hour.3ds")
Global Hand_min = LoadMesh("Hand_min.3ds")
Global Hand_sec = LoadMesh("Hand_sec.3ds")
Global texture = LoadTexture("hand_hour.jpg")
EntityTexture hand_hour,texture
Global light = CreateLight()
Global camera = CreateCamera()
Global zoom# = 1

Global back = LoadImage("background.jpg")

Global clock_choice = 1

Global date_day
Global date_month$
Global date_year

Global do_speak

Global rot = 1 ;rotation variable
Global choice = 0 ;for menu selection

Global chn1#
Global number
Global scroll# = -400

Global menuchoice = 0

Global rotate

Global game 
Global timecount = 1

Global hour1,hour2,min1,min2,sec1,sec2
Global do_save
Global dataname$ = "Systemzeit"
Global new_clock
Global further, clock_timer, show_date


Global UTC$ = "UTC+1"
Global land = 38
Global landstr$

;vars for options
Global option = 1
Global language = 1
Global show_options = 1

;vals for stats
Global first_use_date$
Global first_use_time$
Global all_hour
Global all_min
Global all_sec
Global start_count = MilliSecs()

Global x1,x2,y1,y2,z1,z2 = 0

;values for the clock
Global val_hour
Global val_min
Global val_sec
Global summertime = 0

Global world_hour
Global world_min
Global world_sec
Global hour_dif

;values for spoken time
Global spk_min1
Global spk_min2

;variables for time counting
Global planet1 = 1
Global planet2 = 1
Global planetname1$,planetname2$
Global year1#, year2#
Global age#
Global speed# 
Global percent#
Global dilatation#
Global width#
Global planetchoice

;vars for time counting
Global count_hour1,count_hour2,count_min1,count_min2,count_sec1,count_sec2
Global temp_hour1,temp_hour2,temp_min1,temp_min2,temp_sec1,temp_sec2
Global carry_hour1,carry_hour2,carry_min1,carry_min2,carry_sec1,carry_sec2
Global temp_val
Global do_count = 1

;vars for applics
Global once
Global time_now
Global appchoice
Global time_new
Global do_run
Global old_time#
Global new_time#
Global countdown_min#, countdown_sec#, countdown_min_start, countdown_sec_start
Global temp
Global temp2
Global change
Global alarm_hour1 
Global alarm_hour2 
Global alarm_min1 
Global alarm_min2 
Global activ = 1
Global lap#
Global timechoice

;vars for games
Global time_guess_var
Global rnd_val#
Global play_game = 1
Global val_start#, val_stop#, start_guess
Global difference#,diff#

Global acc_hour,acc_sec
Global acc_min = 10
Global won_hour#,won_min#,won_sec#
Global lost_hour,lost_min,lost_sec
Global tip_hour1,tip_hour2,tip_min1,tip_min2,tip_sec1,tip_sec2
Global lotto_hour1,lotto_hour2,lotto_min1,lotto_min2,lotto_sec1,lotto_sec2
Global now_won#
Global select_lotto
Global cash_hour1#,cash_hour2#,cash_min1#,cash_min2#,cash_sec1#,cash_sec2#
Global not_enough_cash

; Colors
ClsColor 255,255,255
Color 255,0,100


; Fonts
Global font_menu = LoadFont("Comic Sans MS",22,1,0,0)
SetFont font_menu

Global font_title = LoadFont("Comic Sans MS",40,0,0,1)
Global font_time = LoadFont("Arial",80,1,0,0)


;the sounds
Global its = LoadSound("Its.ogg")
Global h0$ = LoadSound("0h.ogg")
Global h1$ = LoadSound("1h.ogg")
Global h2$ = LoadSound("2h.ogg")
Global h3$ = LoadSound("3h.ogg")
Global h4$ = LoadSound("4h.ogg")
Global h5$ = LoadSound("5h.ogg")
Global h6$ = LoadSound("6h.ogg")
Global h7$ = LoadSound("7h.ogg")
Global h8$ = LoadSound("8h.ogg")
Global h9$ = LoadSound("9h.ogg")
Global h10$ = LoadSound("10h.ogg")
Global h11$ = LoadSound("11h.ogg")
Global h12$ = LoadSound("12h.ogg")
Global n1$ = LoadSound("1n.ogg")
Global n2$ = LoadSound("2n.ogg")
Global n3$ = LoadSound("3n.ogg")
Global n4$ = LoadSound("4n.ogg")
Global n5$ = LoadSound("5n.ogg")
Global n6$ = LoadSound("6n.ogg")
Global n7$ = LoadSound("7n.ogg")
Global n8$ = LoadSound("8n.ogg")
Global n9$ = LoadSound("9n.ogg")
Global t10$ = LoadSound("10.ogg")
Global t20$ = LoadSound("20.ogg")
Global t30$ = LoadSound("30.ogg")
Global t40$ = LoadSound("40.ogg")
Global t50$ = LoadSound("50.ogg")
Global t1$ = LoadSound("1.ogg")
Global t2$ = LoadSound("2.ogg")
Global t3$ = LoadSound("3.ogg")
Global t4$ = LoadSound("4.ogg")
Global t5$ = LoadSound("5.ogg")
Global t6$ = LoadSound("6.ogg")
Global t7$ = LoadSound("7.ogg")
Global t8$ = LoadSound("8.ogg")
Global t9$ = LoadSound("9.ogg")
Global t11 = LoadSound("11.ogg")
Global t12 = LoadSound("12.ogg")
Global t13 = LoadSound("13.ogg")
Global t14 = LoadSound("14.ogg")
Global t15 = LoadSound("15.ogg")
Global t16 = LoadSound("16.ogg")
Global t17 = LoadSound("17.ogg")
Global t18 = LoadSound("18.ogg")
Global t19 = LoadSound("19.ogg")

Global beep = LoadSound("beep.ogg")

FirstUse()

Repeat
Cls

UpdateWorld()
RenderWorld()

If choice <> 1 Then DrawImage back,0,0
SelectProgram()
Click()
DrawClock()
DrawText()
CountStats()

Flip 1
Forever

End 


Function FirstUse()

stream = FileType("data.dat")
If stream = 0 Then
	stream = WriteFile("data.dat")
	WriteInt(stream,all_hour)
	WriteInt(stream,all_min)
	WriteInt(stream,all_sec)
	WriteString(stream,CurrentTime())
	WriteString(stream,CurrentDate())
	CloseFile stream
	first_use_time = CurrentTime()
	first_use_date = CurrentDate()
ElseIf stream <> 0 Then
	stream = ReadFile("data.dat")
	all_hour = ReadInt(stream)
	all_min = ReadInt(stream)
	all_sec = ReadInt(stream)
	first_use_time = ReadString(stream)
	first_use_date = ReadString(stream)
	CloseFile stream
EndIf 

End Function 


Function CountStats()
	
	If MilliSecs()-start_count > 1000 And all_sec < 59 Then
		all_sec = all_sec + 1
		start_count = MilliSecs()
	ElseIf MilliSecs()-start_count > 1000 And all_sec >= 59 Then
		all_sec = 0
		all_min = all_min+1
		start_count = MilliSecs()
	ElseIf MilliSecs()-start_count > 1000 And all_min > 59 Then
		all_hour = all_hour + 1
		all_min = 0
		all_sec = 0
		start_count = MilliSecs()
	EndIf 

End Function 

Function Click()

	If KeyHit(205) Then
		If rot < 8 Then
			rot = rot+1
		ElseIf rot = 8 Then
			rot = 1 
		EndIf 
	ElseIf KeyHit(203) Then
		If rot > 1 Then
			rot = rot-1
		ElseIf rot = 1 Then
			rot = 8
		EndIf 
	EndIf 
	
	If KeyHit(28) Then choice = rot
	
End Function 


Function DrawClock()
If choice = 0 Then

	SetFont font_title
	Color 255,50,20
	Text 200,20,"ZEITLOS - Hauptmen",200,200
	SetFont font_menu

	DrawImage Clock_menu,100,100
	
	Select rot
		Case 1 : DrawImage Clockhand1,185,100
		Case 2 : DrawImage Clockhand2,195,120
		Case 3 : DrawImage Clockhand3,200,180
		Case 4 : DrawImage Clockhand4,190,185
		Case 5 : DrawImage Clockhand5,185,200
		Case 6 : DrawImage Clockhand6,120,190
		Case 7 : DrawImage Clockhand7,105,180
		Case 8 : DrawImage Clockhand8,120,120
	End Select

EndIf 	
End Function 


Function DrawText()
If choice = 0 Then

	Color 160,80,80
	Text 200,90,"Uhrzeit",200,200
	Color 232,116,0
	Text 280,118,"Weltzeit"
	Color 232,232,0
	Text 305,180,"Anwendungen"
	Color 116,232,0
	Text 280,260,"Optionen"
	Color 50,178,50
	Text 200,310,"Beenden",200,200
	Color 0,0,160
	Text 60,267,"Statistik"
	Color 150,100,255
	Text 20,185,"Zeitspiele"
	Color 128,160,255
	Text 5,110,"Rechnen mit Zeit"	

EndIf 	
End Function 


Function Options()

	If choice = 4 Then

	SetFont font_title
	Color 255,0,0
	Text 200,10,"OPTIONEN",200,200
	SetFont font_menu
	
	If KeyHit(200) Then
		If option > 1 Then
			option = option-1
		Else
			option = 3
		EndIf
	ElseIf KeyHit(208) Then
		If option < 3 Then
			option = option+1
		Else
			option = 1
		EndIf
	EndIf 
	
	If show_options = 1 Then
		Text 30,80,"Sprache auswhlen: "
		Text 30,120,"Credits anzeigen"
		Text 30,160,"Statistiken zurcksetzen"		
	EndIf 
	
	If show_options = 1 Then
	Select language
			Case 1 : Text 200,80,"Deutsch"
			Case 2 : Text 200,80,"English" 
	End Select
	EndIf 
		
	
	If option = 1 Then
		
		Rect 28,80,150,22,0
	
		If KeyHit(203) Then
			If language > 1 Then
				language = language-1
			Else
				language = 2
			EndIf
		ElseIf KeyHit(205) Then
			If language < 2 Then
				language = language+1
			Else
				language = 1
			EndIf
		EndIf
		
	ElseIf option = 2 Then
	
	If show_options = 1 Then Rect 28,120,127,22,0
	If KeyHit(28) Then show_options = 1-show_options
	
	
	If show_options = 0 Then	
		Text 200,50-scroll,"ZEITLOS - DAS UHRZEIT-TOOL",200,200
		Text 200,90-scroll,"Dieses Tool wurde programmiert im Rahmen",200,200
		Text 200,110-scroll,"des BCC #29.",200,200
		Text 200,140-scroll,"Programmierung: Stefan Behrendt",200,200
		Text 200,180-scroll,"Sounds & Stimme: Stefan Behrendt",200,200
		Text 200,220-scroll,"Texturen erstellt mit: GIMP!2, Paint",200,200
		Text 200,260-scroll,"Modelle erstellt mit: Wings3D",200,200
		Text 200,320-scroll,"(C) 2009 by Dice of Darkness aka Stefan Behrendt",200,200
	
		If scroll < 330 Then scroll = scroll+0.25
		If scroll >= 330 Then scroll = -400
		
		If KeyHit(68) Then show_options = 1
	EndIf 
	
	ElseIf option = 3 Then
	
		Rect 28,160,185,22,0
	
		If KeyHit(28) Then
			DeleteFile "data.dat"
			stream = WriteFile("Data.dat")
			CloseFile stream
			first_use_date = CurrentDate()
			first_use_time = CurrentTime()
			all_hour = 0 : all_min = 0 : all_sec = 0
			countdown_started = 0 : countdown_fail = 0
			;....
		EndIf		
	
	EndIf 
	EndIf 
	
If KeyHit(1) Then
	choice = 0
EndIf 	
	
End Function 


Function Stats()

	If choice = 6 Then

	SetFont font_title
	Color 255,0,0
	Text 200,0-scroll,"STATISTIKEN",200,200
	SetFont font_menu
	Text 200,50-scroll,"Programm-Erstnutzung: "+first_use_date+", "+first_use_time+" Uhr",200,200
	Text 200,80-scroll,"Gesamte Programm-Nutzdauer: "+zerohour$+all_hour+":"+zeromin$+all_min+":"+zerosec$+all_sec+" h",200,200
	Text 200,150-scroll,"ACHTUNG: Das Feature Statistiken ist aus Zeitgrnden",200,200
	Text 200,170-scroll,"nicht fertig geworden. Bitte bercksichtigt es bei eurer",200,200
	Text 200,190-scroll,"Bewertung NICHT! Danke :)",200,200 	
	If scroll < 500 Then scroll = scroll+0.25
	If scroll >= 500 Then scroll = -400
	
	If all_sec < 10 Then zerosec$ = "0"
	If all_sec > 9 Then zerosec$ = ""
	If all_min < 10 Then zeromin$ = "0"
	If all_min > 9 Then zeromin$ = ""
	If all_hour < 10 Then zerohour$ = "0"
	If all_hour > 9 Then zerohour$ = ""
	
	EndIf 
	
If KeyHit(1) Then
	choice = 0
	scroll = -420
EndIf 

End Function 


Function SelectProgram()

	Select choice
		Case 0 : Menu()
		Case 1 : ShowClock()
		Case 2 : WorldTime()
		Case 3 : Applics()
		Case 4 : Options()
		Case 5 : Quit()
		Case 6 : Stats()
		Case 7 : TimeGames()
		Case 8 : TimeCounter()
	End Select 
	
End Function 


Function Menu()
End Function


Function ShowClock()

	If choice = 1 Then
	
	Select appchoice
	
	Case 0

		SetFont font_title
		Color 255,0,0
		Text 200,20,"Uhrzeit",200,200
		SetFont font_menu
		
		Text 10,320,"Uhr einstellen [F5]"
		Text 350,190,"Ansicht [F1]",200,200
		Text 350,210,"Datum [F2]",200,200
		Text 10,360,"Sommerzeit [F3]"
		Text 260,360,"Zeit ansagen [F4]"
		Text 10,340,"Uhrzeit laden [F6]"

		date_day = Int(Left(CurrentDate(),2))
		date_month$ = Mid(CurrentDate(),4,3)
		date_year = Int(Right(CurrentDate(),4))
		
		Select date_month$
		Case "Jan" : date_month$ = "Januar"
		Case "Feb" : date_month$ = "Februar"
		Case "Mar" : date_month$ = "Mrz"
		Case "Apr" : date_month$ = "April"
		Case "May" : date_month$ = "Mai"
		Case "Jun" : date_month$ = "Juni"
		Case "Jul" : date_month$ = "Juli"
		Case "Aug" : date_month$ = "August"
		Case "Sep" : date_month$ = "September"
		Case "Oct" : date_month$ = "Oktober"
		Case "Nov" : date_month$ = "November"
		Case "Dec" : date_month$ = "Dezember"
		End Select 
		
		If show_date = 1 Then Text 200,300,date_day+". "+date_month$+" "+date_year,200,200

		If KeyHit(61) Then 
			If summertime = 0 Then
			summertime = -1
			ElseIf summertime = -1 Then
			summertime = 0
			EndIf
		EndIf 
		
		If KeyHit(60) Then show_date = 1-show_date
		
		If KeyHit(59) Then
			If clock_choice <= 2 Then
				clock_choice = clock_choice + 1
			Else 
				clock_choice = 1
			EndIf
		EndIf 	

	If clock_choice = 1 Then
	
	;the algorithm for the clock
	If new_clock = 0 Then
		val_hour = (Int(Left(CurrentTime(),2)) + summertime)
		val_min = Int(Mid(CurrentTime(),4,2))
		val_sec = Int(Right(CurrentTime(),2))
	ElseIf new_clock = 1 Then
		If MilliSecs()-clock_timer >= 1000 Then further = 1 
	EndIf 
	
	If further = 1 Then
	clock_timer = MilliSecs()
	If val_sec < 59 Then val_sec = val_sec+1
	If val_sec = 59 Then
		If val_min < 60 Then
		val_min = val_min+1
		val_sec = 0
		ElseIf val_min > 59 Then
			If val_hour < 24 Then
			val_hour = val_hour+1
			val_min = 0
			val_sec = 0
			ElseIf val_hour > 23 Then
			val_hour = 0
			val_min = 0
			val_sec = 0
			EndIf
		EndIf	
	EndIf
	further = 0
	EndIf
	
	ShowEntity Clock3d
	ShowEntity Hand_hour
	ShowEntity Hand_min
	ShowEntity Hand_sec
	RotateEntity clock3d,0,270+rotate,0
	PositionEntity Clock3d,x#,y#,z#+2
	PositionEntity Hand_hour,0,0,1.9
	PositionEntity Hand_min,0,0,1.8
	PositionEntity Hand_sec,0,0,1.8
	RotateEntity Hand_hour,0,270+rotate,0
	RotateEntity Hand_min,0,270+rotate,0
	RotateEntity Hand_sec,0,270+rotate,0  
	
	
	If val_hour> 12 Then val_hour = val_hour -12
	
	TurnEntity Hand_hour,((360/12)*val_hour+0.5*val_min),0,0
	TurnEntity Hand_min,((360/60)*val_min),0,0
	TurnEntity Hand_sec,((360/60)*val_sec),0,0
	
	ElseIf clock_choice = 2 Then
	
		HideEntity Clock3d
		HideEntity Hand_hour
		HideEntity Hand_min
		HideEntity Hand_sec

	
		;the algorithm for the clock
	If new_clock = 0 Then
		val_hour = (Int(Left(CurrentTime(),2)) + summertime)
		val_min = Int(Mid(CurrentTime(),4,2))
		val_sec = Int(Right(CurrentTime(),2))
	ElseIf new_clock = 1 Then
		If MilliSecs()-clock_timer >= 1000 Then further = 1 
	EndIf 
	
	If further = 1 Then
	clock_timer = MilliSecs()
	If val_sec < 59 Then val_sec = val_sec+1
	If val_sec = 59 Then
		If val_min < 60 Then
		val_min = val_min+1
		val_sec = 0
		ElseIf val_min > 59 Then
			If val_hour < 24 Then
			val_hour = val_hour+1
			val_min = 0
			val_sec = 0
			ElseIf val_hour > 23 Then
			val_hour = 0
			val_min = 0
			val_sec = 0
			EndIf
		EndIf	
	EndIf
	further = 0
	EndIf
		
		If val_hour >= 10 Then
		For x1 = 1 To Left(val_hour,1)
		Color (8*val_hour+10*x1),128,128
		Text 120,250-(x1*10),"_"
		Next
		EndIf 
		
		For x2 = 1 To Right(val_hour,1)
		Color (5*val_hour+10*x2),128,128
		Text 140,250-(x2*10),"_"
		Next
		
		Text 160,240,":"
		
		If val_min >= 10 Then
		For y1 = 1 To Left(val_min,1) 
		Color 128,(8*val_min+10*x2),128
		Text 180,250-(y1*10),"_"
		Next
		EndIf 
		
		For y2 = 1 To Right(val_min,1)
		Color 128,(5*val_min+10*y2),128
		Text 200,250-(y2*10),"_"
		Next
		
		Text 220,240,":"
		
		If val_sec >= 10 Then
		For z1 = 1 To Left(val_sec,1)
		Color 128,128,(8*val_sec+10*z1)
		Text 240,250-(z1*10),"_"
		Next
		EndIf  
		
		For z2 = 1 To Right(val_sec,1)
		Color 128,128,(5*val_sec+10*z2)
		Text 260,250-(z2*10),"_"
		Next
		
	ElseIf clock_choice = 3 Then
	
		;the algorithm for the clock
	If new_clock = 0 Then
		val_hour = (Int(Left(CurrentTime(),2)) + summertime)
		val_min = Int(Mid(CurrentTime(),4,2))
		val_sec = Int(Right(CurrentTime(),2))
	ElseIf new_clock = 1 Then
		If MilliSecs()-clock_timer >= 1000 Then further = 1 
	EndIf 
	
	If further = 1 Then
	clock_timer = MilliSecs()
	If val_sec < 59 Then val_sec = val_sec+1
	If val_sec = 59 Then
		If val_min < 60 Then
		val_min = val_min+1
		val_sec = 0
		ElseIf val_min > 59 Then
			If val_hour < 24 Then
			val_hour = val_hour+1
			val_min = 0
			val_sec = 0
			ElseIf val_hour > 23 Then
			val_hour = 0
			val_min = 0
			val_sec = 0
			EndIf
		EndIf	
	EndIf
	further = 0
	EndIf

		If language = 1 Then
		Text 155,240,"Uhr"
		Color 255,255,0
		Select val_hour
			Case 00 : Text 100,240,"Null"
			Case 01 : Text 100,240,"Ein"
			Case 02 : Text 100,240,"Zwei"
			Case 03 : Text 100,240,"Drei"
			Case 04 : Text 100,240,"Vier"
			Case 05 : Text 100,240,"Fnf"
			Case 06 : Text 100,240,"Sechs"
			Case 07 : Text 100,240,"Sieben"
			Case 08 : Text 100,240,"Acht"
			Case 09 : Text 100,240,"Neun"
			Case 10 : Text 100,240,"Zehn"
			Case 11 : Text 100,240,"Elf"
			Case 12 : Text 100,240,"Zwlf"
			Case 13 : Text 80,240,"Dreizehn"
			Case 14 : Text 80,240,"Vierzehn"
			Case 15 : Text 80,240,"Fnfzehn"
			Case 16 : Text 80,240,"Sechzehn"
			Case 17 : Text 80,240,"Siebzehn"
			Case 18 : Text 80,240,"Achtzehn"
			Case 19 : Text 80,240,"Neunzehn"
			Case 20 : Text 80,240,"Zwanzig"
			Case 21 : Text 40,240,"Einundzwanzig"
			Case 22 : Text 40,240,"Zweiundzwanzig"
			Case 23 : Text 40,240,"Dreiundzwanzig"
		End Select
		If Left(val_min,1) > 1 And val_min >= 10 Then
		Color 255,128,255
		Select Right(val_min,1)
			Case 1 : Text 200,240,"einund"
			Case 2 : Text 200,240,"zweiund"
			Case 3 : Text 200,240,"dreiund"
			Case 4 : Text 200,240,"vierund"
			Case 5 : Text 200,240,"fnfund"
			Case 6 : Text 200,240,"sechsund"
			Case 7 : Text 200,240,"siebenund"
			Case 8 : Text 200,240,"achtund"
			Case 9 : Text 200,240,"neunund"
		End Select
			ElseIf Left(val_min,1) = 1 And val_min >= 10 Then
			Color 255,128,255
			Select Right(val_min,1)
			Case 0 : Text 200,240,"zehn"
			Case 1 : Text 200,240,"elf"
			Case 2 : Text 200,240,"zwlf"
			Case 3 : Text 200,240,"dreizehn"
			Case 4 : Text 200,240,"vierzehn"
			Case 5 : Text 200,240,"fnfzehn"
			Case 6 : Text 200,240,"sechzehn"
			Case 7 : Text 200,240,"siebzehn"
			Case 8 : Text 200,240,"achtzehn"
			Case 9 : Text 200,240,"neunzehn"
			End Select
			ElseIf Left(val_min,1) = 0 And val_min >= 10 Then
			Color 0,255,255
			Select Right(val_min,1)
			Case 1 : Text 200,240,"eins"
			Case 2 : Text 200,240,"zwei"
			Case 3 : Text 200,240,"drei"
			Case 4 : Text 200,240,"vier"
			Case 5 : Text 200,240,"fnf"
			Case 6 : Text 200,240,"sechs"
			Case 7 : Text 200,240,"sieben"
			Case 8 : Text 200,240,"acht"
			Case 9 : Text 200,240,"neun"
			End Select
			EndIf 
			Color 0,255,255
		Select Left(val_min,1)
			Case 2 : Text 270,240,"zwanzig"
			Case 3 : Text 270,240,"dreiig"
			Case 4 : Text 270,240,"vierzig"
			Case 5 : Text 270,240,"fnfzig"
		End Select 
		
		ElseIf language = 2 Then
		Text 155,240,"o'"
		If Int(Mid(CurrentTime(),4,2)) = 0 Then Text 159,240,"clock"
		Color 255,255,0
		Select val_hour
			Case 00 : Text 100,240,"Twelve" : Text 280,240,"am"
			Case 01 : Text 100,240,"One" : Text 280,240,"am"
			Case 02 : Text 100,240,"Two" : Text 280,240,"am"
			Case 03 : Text 100,240,"Three" : Text 280,240,"am"
			Case 04 : Text 100,240,"Four" : Text 280,240,"am"
			Case 05 : Text 100,240,"Five" : Text 280,240,"am"
			Case 06 : Text 100,240,"Six" : Text 280,240,"am"
			Case 07 : Text 100,240,"Seven" : Text 280,240,"am"
			Case 08 : Text 100,240,"Eight" : Text 280,240,"am"
			Case 09 : Text 100,240,"Nine" : Text 280,240,"am"
			Case 10 : Text 100,240,"Ten" : Text 280,240,"am"
			Case 11 : Text 100,240,"Eleven" : Text 280,240,"am"
			Case 12 : Text 100,240,"Twelve" : Text 280,240,"pm"
			Case 13 : Text 100,240,"One" : Text 280,240,"pm"
			Case 14 : Text 100,240,"Two" : Text 280,240,"pm"
			Case 15 : Text 100,240,"Three" : Text 280,240,"pm"
			Case 16 : Text 100,240,"Four" : Text 280,240,"pm"
			Case 17 : Text 100,240,"Five" : Text 280,240,"pm"
			Case 18 : Text 100,240,"Six" : Text 280,240,"pm"
			Case 19 : Text 100,240,"Seven" : Text 280,240,"pm"
			Case 20 : Text 100,240,"Eight" : Text 280,240,"pm"
			Case 21 : Text 100,240,"Nine" : Text 280,240,"pm"
			Case 22 : Text 100,240,"Ten" : Text 280,240,"pm"
			Case 23 : Text 100,240,"Eleven" : Text 280,240,"pm"
		End Select		
		If Int(Mid(CurrentTime(),4,1)) > 1 Then
		Color 255,128,255
		Select Int(Mid(CurrentTime(),5,1))
			Case 1 : Text 220,240,"one"
			Case 2 : Text 220,240,"two"
			Case 3 : Text 220,240,"three"
			Case 4 : Text 220,240,"four"
			Case 5 : Text 220,240,"five"
			Case 6 : Text 220,240,"six"
			Case 7 : Text 220,240,"seven"
			Case 8 : Text 220,240,"eight"
			Case 9 : Text 220,240,"nine"
		End Select
			ElseIf Int(Mid(CurrentTime(),4,1)) = 1 Then
			Color 255,128,255
			Select Int(Mid(CurrentTime(),5,1))
			Case 0 : Text 200,240,"ten"
			Case 1 : Text 200,240,"eleven"
			Case 2 : Text 200,240,"twelve"
			Case 3 : Text 200,240,"thirteem"
			Case 4 : Text 200,240,"fourteen"
			Case 5 : Text 200,240,"fifteen"
			Case 6 : Text 200,240,"sixteen"
			Case 7 : Text 200,240,"seventeen"
			Case 8 : Text 200,240,"eighteen"
			Case 9 : Text 200,240,"nineteen"
			End Select
			ElseIf Int(Mid(CurrentTime(),4,1)) = 0 Then
			Color 0,255,255
			Select Int(Mid(CurrentTime(),5,1))
			Case 1 : Text 175,240,"one"
			Case 2 : Text 175,240,"two"
			Case 3 : Text 175,240,"three"
			Case 4 : Text 175,240,"four"
			Case 5 : Text 175,240,"five"
			Case 6 : Text 175,240,"six"
			Case 7 : Text 175,240,"seven"
			Case 8 : Text 175,240,"eight"
			Case 9 : Text 175,240,"nine"
			End Select
			EndIf 
			Color 0,255,255
		Select Int(Mid(CurrentTime(),4,1))
			Case 2 : Text 175,240,"twenty"
			Case 3 : Text 175,240,"thirty"
			Case 4 : Text 175,240,"fourty"
			Case 5 : Text 175,240,"fifty"
		End Select 
		EndIf 

	EndIf ;3D-clock
		
	If KeyHit(63) Then appchoice = 1 : number = 0
	If KeyHit(64) Then appchoice = 2 : number = 0
	
	CameraZoom camera,zoom#

	; move the clock
	If KeyDown(205) Then rotate = rotate + 1
	If KeyDown(203) Then rotate = rotate - 1
	If KeyDown(200) And zoom# < 9 Then zoom# = zoom#+0.05
	If KeyDown(208) And zoom# > 0.2 Then zoom# = zoom# - 0.05
	
	
	
	;algorithm to speak the time
	If val_min Mod 10 <> 0 Then
		If val_min > 19 Then  
			spk_min1 = Int(Right(val_min,1))
			spk_min2 = val_min-spk_min1
		ElseIf val_min <= 19 Then
			spk_min1 = 0
			spk_min2 = val_min
		EndIf 
	ElseIf val_min Mod 10 = 0 Then
		spk_min1 = 0
		spk_min2 = val_min
	EndIf 
	
	If KeyHit(62) Then do_speak = 1;F1
	
	If do_speak = 1 Then
	
	Select number
		Case 0
			If ChannelPlaying(chn1) = 0 Then 
			chn1 = PlaySound(its)
			number = number+1
			EndIf 
		Case 1
			If ChannelPlaying(chn1) = 0 Then
			Select val_hour
				Case 0 : chn1 = PlaySound(h0)
				Case 1 : chn1 = PlaySound(h1)
				Case 2 : chn1 = PlaySound(h2)
				Case 3 : chn1 = PlaySound(h3)
				Case 4 : chn1 = PlaySound(h4)
				Case 5 : chn1 = PlaySound(h5)
				Case 6 : chn1 = PlaySound(h6)
				Case 7 : chn1 = PlaySound(h7)
				Case 8 : chn1 = PlaySound(h8)
				Case 9 : chn1 = PlaySound(h9)
				Case 10 : chn1 = PlaySound(h10)
				Case 11 : chn1 = PlaySound(h11)
				Case 12 : chn1 = PlaySound(h12)
			End Select 	
			number = number+1
			EndIf
		Case 2
			If ChannelPlaying(chn1) = 0 Then
			Select spk_min1
				Case 1 : chn1 = PlaySound(n1)
				Case 2 : chn1 = PlaySound(n2)
				Case 3 : chn1 = PlaySound(n3)
				Case 4 : chn1 = PlaySound(n4)
				Case 5 : chn1 = PlaySound(n5)
				Case 6 : chn1 = PlaySound(n6)
				Case 7 : chn1 = PlaySound(n7)
				Case 8 : chn1 = PlaySound(n8)
				Case 9 : chn1 = PlaySound(n9)
			End Select		
			number = number+1
			EndIf
		Case 3
			If ChannelPlaying(chn1) = 0 Then
			Select spk_min2
				Case 10 : chn1 = PlaySound(t10)
				Case 20 : chn1 = PlaySound(t20)
				Case 30 : chn1 = PlaySound(t30)
				Case 40 : chn1 = PlaySound(t40)
				Case 50 : chn1 = PlaySound(t50)
				Case 1 : chn1 = PlaySound(t1)
				Case 2 : chn1 = PlaySound(t2)
				Case 3 : chn1 = PlaySound(t3)
				Case 4 : chn1 = PlaySound(t4)
				Case 5 : chn1 = PlaySound(t5)
				Case 6 : chn1 = PlaySound(t6)
				Case 7 : chn1 = PlaySound(t7)
				Case 8 : chn1 = PlaySound(t8)
				Case 9 : chn1 = PlaySound(t9)
				Case 11 : chn1 = PlaySound(t11)
				Case 12 : chn1 = PlaySound(t12)
				Case 13 : chn1 = PlaySound(t13)
				Case 14 : chn1 = PlaySound(t14)
				Case 15 : chn1 = PlaySound(t15)
				Case 16 : chn1 = PlaySound(t16)
				Case 17 : chn1 = PlaySound(t17)
				Case 18 : chn1 = PlaySound(t18)
				Case 19 : chn1 = PlaySound(t19)	
			End Select	
			number = number+1
			do_speak = 0
			number = 0
			EndIf
	End Select
	
	EndIf 
	
	
	Case 1
	
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Uhrzeit einstellen",200
		SetFont font_menu
		
		Text 160,70,""+hour1+hour2+":"+min1+min2+":"+sec1+sec2+" Uhr"
		
		Select number
		Case 0
			Rect 160,90,10,2
			If KeyHit(208) And hour1 >0 Then hour1 = hour1 - 1
			If KeyHit(208) And hour1 = 0 Then hour1 = 23
			If KeyHit(200) And hour1 <2 Then hour1 = hour1 + 1
			If KeyHit(200) And hour1 = 2 Then hour1 = 0
		Case 1
			Rect 170,90,10,2
			If KeyHit(208) And hour2 >0 Then hour2 = hour2 - 1
			If KeyHit(208) And hour2 = 0 Then hour2 = 23
			If KeyHit(200) And hour2 <9 Then hour2 = hour2 + 1
			If KeyHit(200) And hour2 = 9 Then hour2 = 0
		Case 2
			Rect 185,90,10,2
			If KeyHit(208) And min1 >0 Then min1 = min1 - 1
			If KeyHit(208) And min1 = 0 Then min1 = 23
			If KeyHit(200) And min1 <5 Then min1 = min1 + 1
			If KeyHit(200) And min1 = 5 Then min1 = 0
		Case 3
			Rect 195,90,10,2
			If KeyHit(208) And min2 >0 Then min2 = min2 - 1
			If KeyHit(208) And min2 = 0 Then min2 = 23
			If KeyHit(200) And min2 <9 Then min2 = min2 + 1
			If KeyHit(200) And min2 = 9 Then min2 = 0
		Case 4
			Rect 210,90,10,2
			If KeyHit(208) And sec1 >0 Then sec1 = sec1 - 1
			If KeyHit(208) And sec1 = 0 Then sec1 = 23
			If KeyHit(200) And sec1 <5 Then sec1 = sec1 + 1
			If KeyHit(200) And sec1 = 5 Then sec1 = 0
		Case 5
			Rect 220,90,10,2
			If KeyHit(208) And sec2 >0 Then sec2 = sec2 - 1
			If KeyHit(208) And sec2 = 0 Then sec2 = 23
			If KeyHit(200) And sec2 <9 Then sec2 = sec2 + 1
			If KeyHit(200) And sec2 = 9 Then sec2 = 0
		End Select 
		
		If KeyHit(203) And number > 0 Then number = number-1
		If KeyHit(203) And number < 2 Then number = 5
		If KeyHit(205) And number < 5 Then number = number+1
		If KeyHit(205) And number > 4 Then number = 0
		
		If KeyHit(28) Then do_save = 1
		
		If do_save = 1 Then 
			FlushKeys()
			Locate 10,150
			dataname$ = Input("Dateiname der Uhrzeit: ")
			stream = FileType(dataname$+".clk")
			If stream = 0 Or stream <> 0 Then
				stream = WriteFile(dataname$+".clk")
				WriteInt(stream,hour1)
				WriteInt(stream,hour2)
				WriteInt(stream,min1)
				WriteInt(stream,min2)
				WriteInt(stream,sec1)
				WriteInt(stream,sec2)
				CloseFile stream
				Text 200,230,"Wollen Sie die neue Zeit bernehmen? [j,n]",200,200
				WaitKey()
				If KeyHit(36) Then
					FlushKeys()
					new_clock = 1					
					appchoice = 0
					val_hour = hour1*10+hour2
					val_min = min1*10+min2
					val_sec = sec1*10+sec2
					do_save = 0
					number = 0
				ElseIf KeyHit(49) Then
					new_clock = 0
					appchoice = 0
					do_save = 0
					number = 0
				EndIf
			EndIf
		EndIf  
		
	Case 2
	
		FlushKeys()
		dataname$ = Input("Dateiname der Uhr, die geladen werden soll: ")
			If dataname$ = "system" Then
				val_hour = Int(Left(CurrentTime(),2))
				val_min = Int(Mid(CurrentTime(),4,2))
				val_sec = Int(Right(CurrentTime(),2))
				new_clock = 0
				appchoice = 0				
			Else 
				stream = FileType(dataname$+".clk")
				If stream <> 0 Then
					stream = ReadFile(dataname$+".clk")
					hour1 = ReadInt(stream)
					hour2 = ReadInt(stream)
					min1 = ReadInt(stream)
					min2 = ReadInt(stream)
					sec1 = ReadInt(stream)
					sec2 = ReadInt(stream)
					val_hour = hour1*10+hour2
					val_min = min1*10+min2
					val_sec = sec1*10+sec2
					CloseFile stream
					new_clock = 1
					appchoice = 0
				EndIf
			EndIf 

		
		If KeyHit(2) Then appchoice = 0 : number = 0
		
	End Select 
	

	EndIf 

If KeyHit(1) Then
number = 0
choice = 0
zoom# = 1
rotate = 0
HideEntity Clock3d
HideEntity Hand_hour
HideEntity Hand_min
HideEntity Hand_sec
EndIf 
	
End Function


Function WorldTime()

	If choice = 2 Then
	 
	world_hour = Int(Left(CurrentTime(),2)) + hour_dif
	world_min = Int(Mid(CurrentTime(),4,2)) 
	world_sec = Int(Right(CurrentTime(),2))
		
	If world_sec < 10 Then zero$ = "0"
	If world_sec > 9 Then zero$ = ""
	
	If world_min < 10 Then zeromin$ = "0"
	If world_min > 9 Then zeromin$ = ""
	
	If world_hour < 24 Or world_hour > 33 Then zerohour$ = "" 
	If world_hour > 23 And world_hour < 34 Then zerohour$ = "0"
	
	If world_hour < 0 Then
	world_hour = 24 + world_hour
	ElseIf world_hour > 23 Then
	world_hour = world_hour - 24
	EndIf 
	If world_min < 0 Then
	world_min = 60 + world_min
	world_hour = world_hour - 1
	ElseIf world_min > 59 Then
	world_min = world_min - 60 
	world_hour = world_hour + 1
	EndIf 
	
	Text 260,50,zerohour$+(world_hour)+":"+zeromin$+(world_min)+":"+zero$+world_sec+" Uhr"
	
		For posx = 10 To 230 Step 10
			Color 100,200,200
			Line posx,50,posx,350
		Next
	
	SetFont font_title
	Color 255,0,0
	Text 200,20,"WELTZEIT",200,200
	
	SetFont font_menu
	Text 10,350,"Zeitzone: "+UTC$
	Text 150,350,"Land: "+landstr$
	Text 10,375,"Benutze die Pfeiltasten, um das Land zu ndern."
	
	If KeyHit(203) And land > 1 Then land = land-1
	If KeyHit(205) And land < 80 Then land = land+1
	
	Select land
		Case 1 : landstr$ = "Hawaii (Honolulu)" : UTC$ = "UTC-10" : Rect 10,50,7,300,1 : hour_dif = -11
		Case 2 : landstr$ = "Alaska (Wainwright)" : UTC$ = "UTC-10" : Rect 10,50,7,300,1 : hour_dif = -11
		Case 3 : landstr$ = "Alaska (Anchorage)" : UTC$ = "UTC-9" : Rect 20,50,7,300,1 : hour_dif = -10
		Case 4 : landstr$ = "Kanada (Vancouver)" : UTC$ = "UTC-8" : Rect 30,50,7,300,1 : hour_dif = -9
		Case 5 : landstr$ = "USA (San Francisco)" : UTC$ = "UTC-8" : Rect 30,50,7,300,1 : hour_dif = -9
		Case 6 : landstr$ = "Mexico (Tijuana)" : UTC$ = "UTC-8" : Rect 30,50,7,300,1 : hour_dif = -9
		Case 7 : landstr$ = "USA (Denver)" : UTC$ = "UTC-7" : Rect 40,50,7,300,1 : hour_dif = -8
		Case 8 : landstr$ = "Mexico (Guadalajara)" : UTC$ = "UTC-6" : Rect 50,50,7,300,1 : hour_dif = -7
		Case 9 : landstr$ = "USA (Chicago)" : UTC$ = "UTC-6" : Rect 50,50,7,300,1 : hour_dif = -7
		Case 10 : landstr$ = "Mexico (Mexico City)" : UTC$ = "UTC-6" : Rect 50,50,7,300,1 : hour_dif = -7
		Case 11 : landstr$ = "Kanada (Winnipeg)" : UTC$ = "UTC-6" : Rect 50,50,7,300,1 : hour_dif = -7
		Case 12 : landstr$ = "Ecuador (Quito)" : UTC$ = "UTC-5" : Rect 60,50,7,300,1 : hour_dif = -6
		Case 13 : landstr$ = "Peru (Lima)" : UTC$ = "UTC-5" : Rect 60,50,7,300,1 : hour_dif = -6
		Case 14 : landstr$ = "Kolumbien (Bogota)" : UTC$ = "UTC-5" : Rect 60,50,7,300,1 : hour_dif = -6
		Case 15 : landstr$ = "USA (New York)" : UTC$ = "UTC-4" : Rect 70,50,7,300,1 : hour_dif = -5
		Case 16 : landstr$ = "Kuba (Havanna)" : UTC$ = "UTC-4" : Rect 70,50,7,300,1 : hour_dif = -5
		Case 17 : landstr$ = "Dom. Rep. (Santo Domingo)" : UTC$ = "UTC-4" : Rect 70,50,7,300,1 : hour_dif = -5
		Case 18 : landstr$ = "Venezuela (Caracas)" : UTC$ = "UTC-4" : Rect 70,50,7,300,1 : hour_dif = -5
		Case 19 : landstr$ = "Brasilien (Manaus)" : UTC$ = "UTC-4" : Rect 70,50,7,300,1 : hour_dif = -5
		Case 20 : landstr$ = "Paraguay (Asuncion)" : UTC$ = "UTC-4" : Rect 70,50,7,300,1 : hour_dif = -5
		Case 21 : landstr$ = "Chile (Santiago)" : UTC$ = "UTC-4" : Rect 70,50,7,300,1 : hour_dif = -5
		Case 22 : landstr$ = "Kanada (Halifax)" : UTC$ = "UTC-4" : Rect 70,50,7,300,1 : hour_dif = -5
		Case 23 : landstr$ = "Uruguay (Montevideo)" : UTC$ = "UTC-3" : Rect 80,50,7,300,1 : hour_dif = -4
		Case 24 : landstr$ = "Argentinien (Buenos Aires)" : UTC$ = "UTC-3" : Rect 80,50,7,300,1 : hour_dif = -4
		Case 25 : landstr$ = "Grnland (Nuuk)" : UTC$ = "UTC-3" : Rect 80,50,7,300,1 : hour_dif = -4
		Case 26 : landstr$ = "Brasilien (Rio de Janeiro)" : UTC$ = "UTC-2" : Rect 90,50,7,300,1 : hour_dif = -3
		Case 27 : landstr$ = "Island (Reykjavik)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 28 : landstr$ = "Westsahara (Ajun)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 29 : landstr$ = "Senegal (Dakar)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 30 : landstr$ = "Liberien (Monrovia)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 31 : landstr$ = "England (London)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 32 : landstr$ = "Portugal (Lissabon)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 33 : landstr$ = "Niger (Niamey)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 34 : landstr$ = "Nigeria (Lagos)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 35 : landstr$ = "Kongo (Kinshasa)" : UTC$ = "UTC" : Rect 110,50,7,300,1 : hour_dif = -1
		Case 36 : landstr$ = "Namibia (Windhoek)" : UTC$ = "UTC+1" : Rect 120,50,7,300,1 : hour_dif = 0
		Case 37 : landstr$ = "Norwegen (Oslo)" : UTC$ = "UTC+1" : Rect 120,50,7,300,1 : hour_dif = 0
		Case 38 : landstr$ = "Deutschland (Berlin)" : UTC$ = "UTC+1" : Rect 120,50,7,300,1 : hour_dif = 0
		Case 39 : landstr$ = "Belgien (Brssel)" : UTC$ = "UTC+1" : Rect 120,50,7,300,1 : hour_dif = 0
		Case 40 : landstr$ = "Frankreich (Paris)" : UTC$ = "UTC+1" : Rect 120,50,7,300,1 : hour_dif = 0
		Case 41 : landstr$ = "Serbien (Belgrad)" : UTC$ = "UTC+1" : Rect 120,50,7,300,1 : hour_dif = 0
		Case 42 : landstr$ = "Ungarn (Budapest)" : UTC$ = "UTC+1" : Rect 120,50,7,300,1 : hour_dif = 0
		Case 43 : landstr$ = "Spanien (Madrid)" : UTC$ = "UTC+1" : Rect 120,50,7,300,1 : hour_dif = 0
		Case 44 : landstr$ = "gypten (Kairo)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 45 : landstr$ = "Simbabwe (Harare)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 46 : landstr$ = "Sdafrika (Kapstadt)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 47 : landstr$ = "Finnland (Helsinki)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 48 : landstr$ = "Weirussland (Kiew)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 49 : landstr$ = "Rumnien (Bukarest)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 50 : landstr$ = "Trkei (Ankara)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 51 : landstr$ = "Griechenland (Athen)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 52 : landstr$ = "Somalia (Mogadischu)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 53 : landstr$ = "Tansania (Daressalam)" : UTC$ = "UTC+2" : Rect 130,50,7,300,1 : hour_dif = 1
		Case 54 : landstr$ = "Saudi-Arabien (Riad)" : UTC$ = "UTC+3" : Rect 140,50,7,300,1 : hour_dif = 2
		Case 55 : landstr$ = "Irak (Bagdad)" : UTC$ = "UTC+3" : Rect 140,50,7,300,1 : hour_dif = 2 
		Case 56 : landstr$ = "Madagaskar (Antananarivo)" : UTC$ = "UTC+3" : Rect 140,50,7,300,1 : hour_dif = 2 
		Case 57 : landstr$ = "Russland (Moskau)" : UTC$ = "UTC+3" : Rect 140,50,7,300,1 : hour_dif = 2
		Case 58 : landstr$ = "V.A.E. (Dubai)" : UTC$ = "UTC+4" : Rect 150,50,7,300,1 : hour_dif = 3 
		Case 59 : landstr$ = "Usbekistan (Taschkent)" : UTC$ = "UTC+5" : Rect 160,50,7,300,1 : hour_dif = 4
		Case 60 : landstr$ = "Russland (Jekaterinburg)" : UTC$ = "UTC+5" : Rect 160,50,7,300,1 : hour_dif = 4 
		Case 61 : landstr$ = "Kasachstan (Astana)" : UTC$ = "UTC+6" : Rect 170,50,7,300,1 : hour_dif = 5
		Case 62 : landstr$ = "Thailand (Bangkok)" : UTC$ = "UTC+7" : Rect 180,50,7,300,1 : hour_dif = 6
		Case 63 : landstr$ = "Vietnam (Hanoi)" : UTC$ = "UTC+7" : Rect 180,50,7,300,1 : hour_dif = 6
		Case 64 : landstr$ = "Kambodscha (Phnom Penh)" : UTC$ = "UTC+7" : Rect 180,50,7,300,1 : hour_dif = 6
		Case 65 : landstr$ = "Indonesien (Jakarta)" : UTC$ = "UTC+7" : Rect 180,50,7,300,1 : hour_dif = 6
		Case 66 : landstr$ = "Mongolei (Ulaanbaatar)" : UTC$ = "UTC+8" : Rect 190,50,7,300,1 : hour_dif = 7
		Case 67 : landstr$ = "China (Shanghai)" : UTC$ = "UTC+8" : Rect 190,50,7,300,1 : hour_dif = 7
		Case 68 : landstr$ = "Philippinen (Manila)" : UTC$ = "UTC+8" : Rect 190,50,7,300,1 : hour_dif = 7
		Case 69 : landstr$ = "Singapur (Singapur)" : UTC$ = "UTC+8" : Rect 190,50,7,300,1 : hour_dif = 7
		Case 70 : landstr$ = "Australien (Perth)" : UTC$ = "UTC+8" : Rect 190,50,7,300,1 : hour_dif = 7
		Case 71 : landstr$ = "Russland (Jakutsk)" : UTC$ = "UTC+9" : Rect 200,50,7,300,1 : hour_dif = 8
		Case 72 : landstr$ = "Sdkorea (Seoul)" : UTC$ = "UTC+9" : Rect 200,50,7,300,1 : hour_dif = 8
		Case 73 : landstr$ = "Japan (Tokio)" : UTC$ = "UTC+9" : Rect 200,50,7,300,1 : hour_dif = 8
		Case 74 : landstr$ = "Australien (Sydney)" : UTC$ = "UTC+10" : Rect 210,50,7,300,1 : hour_dif = 9
		Case 75 : landstr$ = "Tasmanien (Hobart)" : UTC$ = "UTC+10" : Rect 210,50,7,300,1 : hour_dif = 9
		Case 76 : landstr$ = "Russland (Wladiwostok)" : UTC$ = "UTC+10" : Rect 210,50,7,300,1 : hour_dif = 9
		Case 77 : landstr$ = "Mikronesien (Palikir)" : UTC$ = "UTC+11" : Rect 220,50,7,300,1 : hour_dif = 10
		Case 78 : landstr$ = "Tuvalu (Funafuti)" : UTC$ = "UTC+12" : Rect 230,50,7,300,1 : hour_dif = 11
		Case 79 : landstr$ = "Fidschi (Suva)" : UTC$ = "UTC+12" : Rect 230,50,7,300,1 : hour_dif = 11
		Case 80 : landstr$ = "Neuseeland (Wellington)" : UTC$ = "UTC+12" : Rect 230,50,7,300,1 : hour_dif = 11
		Case 81 : landstr$ = "Russland (Kamtschatka)" : UTC$ = "UTC+12" : Rect 230,50,7,300,1 : hour_dif = 11
	End Select 	
	
	EndIf 
	
If KeyHit(1) Then
	choice = 0
EndIf 

End Function


Function Applics()

	If choice = 3 Then
	
		Select appchoice
		
		Case 0
		
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Anwendungen",200,200
		SetFont font_menu
		
		Text 200,100,"Stoppuhr",200
		Text 200,150,"Countdown",200
		Text 200,200,"Alarm",200
		
		Oval 110,100,25,25,0
		Line 122,95,122,105
		Line 112,95,132,95
		Line 110,111,115,111
		Line 129,111,134,111
		Line 122,119,122,124
		
		Line 110,167,130,147
		Line 110,152,110,167
		Line 110,167,125,167
		
		Oval 110,200,25,25,0
		Line 115,221,110,225
		Line 130,221,135,225
		Oval 110,200,4,4
		Oval 131,200,4,4
		
		Select menuchoice
		
		Case 0
			Rect 163,103,75,20,0
		Case 1
			Rect 160,153,80,20,0
		Case 2
			Rect 176,203,50,20,0
		End Select 
		
		
		If KeyHit(208) Then
			If menuchoice < 3 Then menuchoice = menuchoice + 1
			If menuchoice > 2 Then menuchoice = 0
		ElseIf KeyHit(200) Then
			If menuchoice > (-1) Then menuchoice = menuchoice - 1
			If menuchoice < 0 Then menuchoice = 2
		EndIf 
		
		If KeyHit(28) Then appchoice = menuchoice+1 : menuchoice = 0
		
		Case 1 ;Stoppuhr
		
			SetFont font_title
			Color 255,0,0
			Text 200,20,"Stoppuhr",200,200
			SetFont font_menu
			
			Text 10,340,"Start / Stopp [Enter]"
			Text 10,360,"Zwischenspeichern (LAP) [Leertaste]"
			
			If KeyHit(28) Then
				If do_run = 0 Then
					do_run = 1
					old_time = MilliSecs()
					menuchoice = 1
				ElseIf do_run = 1 Then
					do_run = 0
					new_time = MilliSecs()
					menuchoice = 2
				EndIf
			EndIf 
			
			If KeyHit(57) And menuchoice = 1 Then lap# = (MilliSecs()-old_time#)/1000
			Text 200,250,"LAP: "+lap#,200,200
			
			SetFont font_time
			Select menuchoice
				Case 0 : Text 200,200,(new_time# - old_time#)/1000,200,200
				Case 1 : Text 200,200,(MilliSecs()-old_time#)/1000,200,200
				Case 2 : Text 200,200,(new_time# - old_time#)/1000,200,200
			End Select
			
			If KeyHit(68) Then appchoice = 0
			
		Case 2
		
			SetFont font_title
			Color 255,0,0
			Text 200,20,"Countdown",200,200
			SetFont font_menu
			
			If countdown_min# < 10 Then zeromin$ = "0"
			If countdown_min# > 9 Then zeromin$ = ""
			If countdown_sec# < 10 Then zerosec$ = "0"
			If countdown_sec# > 9 Then zerosec$ = ""
		
			Text 10,320,"Start! [Enter]"
			Text 10,340,"Einstellen [F1]"
			Text 10,360,"Zurcksetzen [Backspace]"
			SetFont font_time
			Text 200,200,""+zeromin$+Int(countdown_min#)+":"+zerosec$+Int(countdown_sec#),200,200
			SetFont font_menu
			
			If KeyHit(14) Then
				countdown_min# = countdown_min_start
				countdown_sec# = countdown_sec_start
			EndIf
			
			Select menuchoice
			
			Case 0
			
			If KeyHit(59) Then menuchoice = 4 : timechoice = 0
			
			
			If KeyHit(28) Then
				If do_run = 0 Then
					do_run = 1
					menuchoice = 1
				ElseIf do_run = 1 Then
					do_run = 0
					;menuchoice = 2
				EndIf
			EndIf  
			

				Case 1
					temp = Int(Right(CurrentTime(),2))
					If change = 0 Then
						change = 1
						temp2 = temp
					ElseIf temp <> temp2 Then 
						If countdown_sec# > 0 Then
							countdown_sec# = countdown_sec# - 1
							change = 0
						ElseIf countdown_sec# <= 0 Then 
							countdown_min# = countdown_min# - 1
							countdown_sec# = 59
							change = 0
						EndIf 
					EndIf 
					
					If countdown_sec# = 0 And countdown_min# = 0 Then
						menuchoice = 3
						If Not ChannelPlaying(chn1) Then chn1 = PlaySound(beep) 
					EndIf
					
					If KeyHit(28) Then do_run = 0 : menuchoice = 0
					
				;Case 2 : Text 200,230,"Countdown gestoppt!",200,200 : If KeyHit(28) Then StopChannel (chn1) : menuchoice = 0
				
				Case 3 : Text 200,230,"Countdown abgelaufen!!!",200,200 : If KeyHit(28) Then StopChannel (chn1) : menuchoice = 0 : countdown_min# = countdown_min_start : countdown_sec# = countdown_sec_start

					
			
			Case 4
			
			Text 200,150,"Stelle die Zeit ein: "+zeromin$+Int(countdown_min#)+":"+zerosec$+Int(countdown_sec#),200,200
			
				Select timechoice
					Case 0 : Rect 250,160,20,2
						If KeyHit(200) And countdown_min# < 59 Then countdown_min# = countdown_min#+1
						If KeyHit(208) And countdown_min# > 0 Then countdown_min# = countdown_min#-1
					Case 1 : Rect 275,160,20,2
						If KeyHit(200) And countdown_sec# < 59 Then countdown_sec# = countdown_sec#+1
						If KeyHit(208) And countdown_sec# > 0 Then countdown_sec# = countdown_sec#-1					
				End Select
				
				If KeyHit(203) Or KeyHit(205) Then timechoice = 1-timechoice
				
				If KeyHit(28) Then
				countdown_min_start = countdown_min#
				countdown_sec_start = countdown_sec#
				menuchoice = 0
				EndIf 
			
			End Select
			
			If KeyHit(68) Then
				appchoice = 0
				menuchoice = 0
			EndIf 

		Case 3
			
			SetFont font_title
			Color 255,0,0
			Text 200,20,"Wecker",200,200
			SetFont font_menu
			
			Text 10,320,"aktiv [Leertaste]: "+activ
			Text 10,340,"ndern [F1]"
			SetFont font_time
			Text 200,200,""+alarm_hour1+alarm_hour2+":"+alarm_min1+alarm_min2,200,200
			SetFont font_menu
			
			If KeyHit(59) Then menuchoice = 1
			
			Select menuchoice
			
			Case 0	
			If activ = 1 And alarm_hour1 = Int(Left(CurrentTime(),1)) And alarm_hour2 = Int(Mid(CurrentTime(),2,1)) And alarm_min1 = Int(Mid(CurrentTime(),4,1)) And alarm_min2 = Int(Mid(CurrentTime(),5,1)) Then
				If Not ChannelPlaying(chn1) Then chn1 = PlaySound(beep)
			EndIf 
			
			If KeyHit(57) Then activ = 1-activ
			
			Case 1
			Text 0,150,"Stelle die Zeit ein: "+alarm_hour1+alarm_hour2+":"+alarm_min1+alarm_min2
			Select number
					Case 0 : Rect 145,170,10,2
						If KeyHit(200) And alarm_hour1 < 5 Then alarm_hour1 = alarm_hour1+1
						If KeyHit(208) And alarm_hour1 > 0 Then alarm_hour1 = alarm_hour1-1
					Case 1 : Rect 155,170,10,2
						If KeyHit(200) And alarm_hour2 < 9 Then alarm_hour2 = alarm_hour2+1
						If KeyHit(208) And alarm_hour2 > 0 Then alarm_hour2 = alarm_hour2-1
					Case 2 : Rect 170,170,10,2
						If KeyHit(200) And alarm_min1 < 5 Then alarm_min1 = alarm_min1+1
						If KeyHit(208) And alarm_min1 > 0 Then alarm_min1 = alarm_min1-1
					Case 3 : Rect 180,170,10,2
						If KeyHit(200) And alarm_min2 < 9 Then alarm_min2 = alarm_min2+1
						If KeyHit(208) And alarm_min2 > 0 Then alarm_min2 = alarm_min2-1
				End Select
				
				If KeyHit(203) Then
					If number > 0 Then
						number = number-1
					Else
						number = 3
					EndIf
				ElseIf KeyHit(205) Then
					If number < 3 Then
						number = number+1
					Else
						number = 0
					EndIf
				EndIf 
				
			If KeyHit(28) Then menuchoice = 0
			End Select 
			
			If KeyHit(68) Then
				appchoice = 0
				menuchoice = 0
			EndIf 
		 	
		End Select 		
				
		
	EndIf 

If KeyHit(1) Then
	choice = 0
	appchoice = 0
	menuchoice = 0
EndIf 

End Function


Function Quit()

	If choice = 5 Then
	
	Color 128,64,0
	Rect 100,150,200,100,0
	Text 200,200,"Wirklich beenden?",200,200
	Text 150,230,"Ja! [J]",200,200
	Text 250,230,"Nein! [N]",200,200
	
	If KeyHit(36) Then
		stream = OpenFile("data.dat")
		WriteInt(stream,all_hour)
		WriteInt(stream,all_min)
		WriteInt(stream,all_sec)
		CloseFile stream
		End 
	ElseIf KeyHit(49) Then
		choice = 0
	EndIf 
	
	EndIf 

End Function


Function TimeGames()

	If choice = 7 Then
	
	Select game
	
	Case 0
	
	;FlushKeys()
	
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Zeitspiele",200,200
		SetFont font_menu
		
		Text 50,180,"Zeit abschtzen"
		Text 190,180,"Zeit-Glcksspiel"
		
		If KeyHit(203) Or KeyHit(205) Then number = 1-number
		
		Select number
			Case 0 : Rect 48,180,120,22,0
			If KeyHit(28) Then game = 1 : play_game = 0
			Case 1 : Rect 188,180,120,22,0
			If KeyHit(28) Then game = 2 : play_game = 0
		End Select
		
		
	Case 1
	
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Zeit abschtzen",200,200
		SetFont font_menu
		
		Select play_game
		
		Case 0		
			Text 200,70,"Bei diesem Spiel kannst du trainieren,",200,200
			Text 200,90,"wie gut du eine kurze Zeitspanne (zwischen",200,200
			Text 200,110,"5 und 30 Sekunden) abschtzen kannst.",200,200
			Text 200,180,"Whle deine Spielvariante:",200,200
			Text 200,240,"Drcke dann Enter zum Starten!",200,200
		
			If KeyHit(203) Then time_guess_var = 1-time_guess_var
			If KeyHit(205) Then time_guess_var = 1-time_guess_var
		
				Select time_guess_var
					Case 0 : Text 200,210,"Computergenerierte Zeit schtzen",200,200
					Case 1 : Text 200,210,"Abwarten und danach schtzen",200,200
				End Select 
		
				If KeyHit(28) Then
					If time_guess_var = 0 Then play_game = 1 : rnd_val# = Rnd(5.0,29.9)
					If time_guess_var = 1 Then play_game = 5
				EndIf 
		
		Case 1
			Text 200,220,"Zufllig gewhlte Zeit: "+rnd_val#,200,200
			Text 200,240,"Drcke Enter zum Starten / Stoppen!",200,200
			
			If KeyHit(28) Then play_game = 2
			
			
		Case 2	
			 val_start# = MilliSecs()
			play_game = 3
			
		Case 3
			For xxx = 0 To 400 Step 20
			For yyy = 50 To 400 Step 20
				Text xxx,yyy,Rand(0,9)
			Next
			Next
		
			If KeyHit(28) Then
				val_stop# = MilliSecs()
				play_game = 4
				difference# = ((val_stop#-val_start#)/1000)
			EndIf 
			
		Case 4
			Text 10,170,"Vorgegeben waren: "+rnd_val#+" Sekunden."
			Text 10,200,"Du hast "+difference#+" Sekunden geschtzt."
			Text 10,220,"Die Differenz zwischen vorgegebener und"
			If (difference#-rnd_val#) > 0 Then
				diff# = (difference#-rnd_val#)
			Else
				diff# = (rnd_val#-difference#)
			EndIf 
			Text 10,240,"geschtzter Zeit betrgt "+diff#+" Sekunden."
			If diff# < 1.0 Then
				Text 10,260,"Perfekt geschtzt!"
			ElseIf diff# > 1 And diff# < 2 Then
				Text 10,260,"Das war sehr gut geschtzt!"
			ElseIf diff# > 2 And diff# < 3.5 Then
				Text 10,260,"Deine Schtzung war schon ordentlich."
			ElseIf diff# > 3.5 And diff# < 5 Then
				Text 10,260,"Naja, das war mittelmig geschtzt."
			ElseIf diff# > 5 And diff# < 7 Then
				Text 10,260,"Du musst zugeben, das ist noch verbesserungswrdig..."
			ElseIf diff# >= 7.0 Then
				Text 10,260,"Ziemlich schlecht. Du musst wohl noch viel ben!!"
			EndIf  
			
			If KeyHit(28) Then play_game = 0 : xxx = 0 : yyy = 0
			
		Case 5
			Text 200,50,"Drcke Enter, dann fngt die Zeit an zu zhlen!",200,200
			If KeyHit(28) Then
				val_start# = MilliSecs()
				play_game = 6
			EndIf 
			
		Case 6
			For xxx = 0 To 400 Step 20
				For yyy = 50 To 400 Step 20
					Text xxx,yyy,Rand(0,9)
				Next
				Next
			If KeyHit(28) Then
				val_stop# = MilliSecs()
				difference# = (val_stop# - val_start#)/1000
				play_game = 7 
			EndIf 
		
		Case 7
			Locate 50,100
			diff# = Input("Deine geschtzte Zeit in Sekunden: ")
			If (diff# - difference#) > 0 Then
				rnd_val# = (diff#-difference#)
			Else
				rnd_val# = (difference#-diff#)
			EndIf 
			If KeyHit(28) Then FlushKeys() : play_game = 8
			
		Case 8
			Text 200,100,"Deine geschtzte Zeit in Sekunden: "+diff#,200,200
			Text 200,120,"Tatschlich vergangene Zeit: "+difference#+" Sekunden.",200,200
			Text 200,140,"Differenz der Zeiten: "+rnd_val#+" Sekunden.",200,200
			If rnd_val# < 1.0 Then
				Text 200,260,"Perfekt geschtzt!",200,200
			ElseIf rnd_val# > 1 And rnd_val# < 2 Then
				Text 200,260,"Das war sehr gut geschtzt!",200,200
			ElseIf rnd_val# > 2 And rnd_val# < 3.5 Then
				Text 200,260,"Deine Schtzung war schon ordentlich.",200,200
			ElseIf rnd_val# > 3.5 And rnd_val# < 5 Then
				Text 200,260,"Naja, das war mittelmig geschtzt.",200,200
			ElseIf rnd_val# > 5 And rnd_val# < 7 Then
				Text 200,260,"Du musst zugeben, das ist etwas verbesserungswrdig...",200,200
			ElseIf rnd_val# >= 7.0 Then
				Text 200,260,"Ziemlich schlecht. Du musst wohl noch viel ben!!",200,200
			EndIf
			
			If KeyHit(28) Then play_game = 0 : xxx = 0 : yyy = 0
		End Select 
		
		If KeyHit(68) Then
			game = 0
			play_game = 0
		EndIf 
		
	Case 2
	
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Das Zeit-Glcksspiel",200,200
		SetFont font_menu
		
		If acc_sec >= 60 Then
			acc_min = acc_min+1
			acc_sec = acc_sec - 60
		ElseIf acc_min >= 60 Then
			acc_hour = acc_hour+1
			acc_min = acc_min - 60
		EndIf 
		
		If acc_sec < 10 Then zerosec$ = "0"
		If acc_sec >= 10 Then zerosec$ = ""
		If acc_min < 10 Then zeromin$ = "0"
		If acc_min >= 10 Then zeromin$ = ""
		If acc_hour < 10 Then zerohour$ = "0"
		If acc_hour >= 10 Then zerohour$ = ""
		
		
		Select play_game
		
		Case 0
			Text 200,70,"Bei diesem Zeit-Glcksspiel generiert der Computer",200,200
			Text 200,90,"eine zufllige Uhrzeit zwischen 00:00:00 Uhr und",200,200
			Text 200,110,"23:59:59 Uhr. Zuvor gibt der Spieler einen Tipp",200,200
			Text 200,130,"ab, welche Uhrzeit kommen knnte. Fr jede richtige",200,200
			Text 200,150,"Zahl gibt es Zeitpunkte, aber auch fr richtige",200,200
			Text 200,170,"Zahlen, die in den Blocks vertauscht sind.",200,200
			Text 200,200,"Die genauen Regeln stehen in der Readme.txt.",200,200
			
			Text 10,280,"Dein Zeitkonto: "+zerohour$+acc_hour+":"+zeromin$+acc_min+":"+zerosec$+acc_sec
			Text 10,300,"bisher gewonnen: "+Int(won_hour#)+":"+Int(won_min#)+":"+Int(won_sec#)
			Text 10,320,"bisher verloren: "+lost_hour+":"+lost_min+":"+lost_sec
			Text 200,360,"Spieleinsatz: "+Int(cash_hour1)+Int(cash_hour2)+":"+Int(cash_min1)+Int(cash_min2)+":"+Int(cash_sec1)+Int(cash_sec2)
			
			Text 200,220,"Drcke Enter, um ein neues Spiel zu starten!",200,200
			
			If not_enough_cash = 1 Then Text 200,350,"So viel Zeit kannst du nicht setzen!",200,200
			If not_enough_cash = 2 Then Text 200,350,"Der Einsatz ist zu gering!",200,200
			
			If KeyHit(28) Then
				If (cash_hour1*10+cash_hour2)*3600+(cash_min1*10+cash_min2)*60+(cash_sec1*10+cash_sec2) <= (acc_hour)*3600+(acc_min)*60+(acc_sec) And (cash_hour1*10+cash_hour2)*3600+(cash_min1*10+cash_min2)*60+(cash_sec1*10+cash_sec2) >= 10 Then
					play_game = 1 
					number = 1
					not_enough_cash = 0
					lost_hour = lost_hour+(cash_hour1*10+cash_hour2)
					lost_min = lost_min+(cash_min1*10+cash_min2)
					lost_sec = lost_sec+(cash_sec1*10+cash_sec2)
				ElseIf (cash_hour1*10+cash_hour2)*3600+(cash_min1*10+cash_min2)*60+(cash_sec1*10+cash_sec2) < 10 Then
					not_enough_cash = 2
				Else 
					not_enough_cash = 1
				EndIf
			EndIf 
			
			If KeyHit(203) Then
				If menuchoice > 0 Then
					menuchoice = menuchoice-1
				Else
					menuchoice = 5
				EndIf
			ElseIf KeyHit(205) Then
				If menuchoice < 5 Then
					menuchoice = menuchoice+1
				Else
					menuchoice = 0
				EndIf
			EndIf 
			
			Select menuchoice
				Case 0 : Rect 297,380,10,2
					If KeyHit(200) And cash_hour1 < 2 Then cash_hour1 = cash_hour1+1
					If KeyHit(208) And cash_hour1 > 0 Then cash_hour1 = cash_hour1-1
				Case 1 : Rect 307,380,10,2
					If KeyHit(200) And cash_hour2 < 9 Then cash_hour2 = cash_hour2+1
					If KeyHit(208) And cash_hour2 > 0 Then cash_hour2 = cash_hour2-1
				Case 2 : Rect 322,380,10,2
					If KeyHit(200) And cash_min1 < 5 Then cash_min1 = cash_min1+1
					If KeyHit(208) And cash_min1 > 0 Then cash_min1 = cash_min1-1
				Case 3 : Rect 332,380,10,2
					If KeyHit(200) And cash_min2 < 9 Then cash_min2 = cash_min2+1
					If KeyHit(208) And cash_min2 > 0 Then cash_min2 = cash_min2-1
				Case 4 : Rect 347,380,10,2
					If KeyHit(200) And cash_sec1 < 5 Then cash_sec1 = cash_sec1+1
					If KeyHit(208) And cash_sec1 > 0 Then cash_sec1 = cash_sec1-1
				Case 5 : Rect 357,380,10,2
					If KeyHit(200) And cash_sec2 < 9 Then cash_sec2 = cash_sec2+1
					If KeyHit(208) And cash_sec2 > 0 Then cash_sec2 = cash_sec2-1
			End Select 				
			
			If acc_sec < 0 Then
				acc_min = acc_min -1
				acc_sec = 60-acc_sec
			ElseIf acc_min < 0 Then
				acc_hour = acc_hour-1
				acc_min = 60-acc_min
			EndIf 
			
			If won_sec# > 59 Then
				won_min# = won_min#+1
				won_sec# = 60-won_sec#
			ElseIf won_min# > 59 Then
				won_hour# = won_hour#+1
				won_min# = 60-won_min#
			EndIf  
			
			If acc_hour <= 0 And acc_min <= 0 And acc_sec <= 0 Then
				Text 200,350,"Du hast alles verloren! Bitte Backspace [<-] drcken.",200,200
				If KeyHit(14) Then acc_min = 10 : lost_hour = 0 : lost_min = 0 : lost_sec = 0 : won_hour = 0 : won_min = 0 : won_sec = 0
			EndIf 
			
		Case 1
			Text 10,150,"DEIN TIPP: "
			Text 100,150,""+tip_hour1+tip_hour2+":"+tip_min1+tip_min2+":"+tip_sec1+tip_sec2
			
			If KeyHit(203) And number > 1 Then number = number-1
			If KeyHit(205) And number < 6 Then number = number+1
			
			Select number
			Case 1
				Rect 100,170,10,2
				If KeyHit(200) And tip_hour1 < 2 Then tip_hour1 = tip_hour1+1
				If KeyHit(208) And tip_hour1 > 0 Then tip_hour1 = tip_hour1-1
			Case 2
				Rect 110,170,10,2
				If KeyHit(200) And tip_hour2 < 9 Then tip_hour2 = tip_hour2+1
				If KeyHit(208) And tip_hour2 > 0 Then tip_hour2 = tip_hour2-1
			Case 3
				Rect 125,170,10,2
				If KeyHit(200) And tip_min1 < 5 Then tip_min1 = tip_min1+1
				If KeyHit(208) And tip_min1 > 0 Then tip_min1 = tip_min1-1
			Case 4
				Rect 135,170,10,2
				If KeyHit(200) And tip_min2 < 9 Then tip_min2 = tip_min2+1
				If KeyHit(208) And tip_min2 > 0 Then tip_min2 = tip_min2-1
			Case 5
				Rect 150,170,10,2
				If KeyHit(200) And tip_sec1 < 5 Then tip_sec1 = tip_sec1+1
				If KeyHit(208) And tip_sec1 > 0 Then tip_sec1 = tip_sec1-1
			Case 6
				Rect 160,170,10,2
				If KeyHit(200) And tip_sec2 < 9 Then tip_sec2 = tip_sec2+1
				If KeyHit(208) And tip_sec2 > 0 Then tip_sec2 = tip_sec2-1
			End Select
			
			If KeyHit(28) Then
			play_game = 2
			select_lotto = 1
			EndIf 
			
		Case 2
			Text 10,150,"DEIN TIPP: "
			Text 100,150,""+tip_hour1+tip_hour2+":"+tip_min1+tip_min2+":"+tip_sec1+tip_sec2
			
			If select_lotto = 1 Then
			lotto_hour1 = Rnd(0,2)
			If lotto_hour1 = 2 Then
				lotto_hour2 = Rnd(0,3)
			Else
				lotto_hour2 = Rnd(0,9)
			EndIf 
			lotto_min1 = Rnd(0,5)
			lotto_min2 = Rnd(0,9)
			lotto_sec1 = Rnd(0,5)
			lotto_sec2 = Rnd(0,9)
			select_lotto = 0
			EndIf  
			
			Text 10,180,"Die heute gezogene Zeit lautet: "+lotto_hour1+lotto_hour2+":"+lotto_min1+lotto_min2+":"+lotto_sec1+lotto_sec2
			
			If select_lotto = 0 Then
			If tip_hour1 = lotto_hour1 Then now_won = now_won + (cash_hour1*10000)+(cash_hour2*1000)+(cash_min1*100)+(cash_min2*10)+(cash_sec1-(cash_sec1-1))
			If tip_hour2 = lotto_hour2 Then now_won = now_won + (cash_hour1*10000)+(cash_hour2*1000)+(cash_min1*100)+(cash_min2*10)+(cash_sec1-(cash_sec1-1))
			If tip_min1 = lotto_min1 Then now_won = now_won + (cash_hour1*10000)+(cash_hour2*1000)+(cash_min1*100)+(cash_min2*10)+(cash_sec1-(cash_sec1-1))
			If tip_min2 = lotto_min2 Then now_won = now_won + (cash_hour1*10000)+(cash_hour2*1000)+(cash_min1*100)+(cash_min2*10)+(cash_sec1-(cash_sec1-1))
			If tip_sec1 = lotto_sec1 Then now_won = now_won + (cash_hour1*10000)+(cash_hour2*1000)+(cash_min1*100)+(cash_min2*10)+(cash_sec1-(cash_sec1-1))
			If tip_sec2 = lotto_sec2 Then now_won = now_won + (cash_hour1*10000)+(cash_hour2*1000)+(cash_min1*100)+(cash_min2*10)+(cash_sec1-(cash_sec1-1))
			
			If tip_hour1 = lotto_hour2 And tip_hour1 <> lotto_hour1 Then now_won = now_won + (cash_hour1*5000)+(cash_hour2*500)+(cash_min1*50)+(cash_min2*5)+(cash_sec1-(cash_sec1-5))			
			If tip_hour2 = lotto_hour1 And tip_hour2 <> lotto_hour2 Then now_won = now_won + (cash_hour1*5000)+(cash_hour2*500)+(cash_min1*50)+(cash_min2*5)+(cash_sec1-(cash_sec1-5))
			If tip_min1 = lotto_min2 And tip_min1 <> lotto_min1 Then now_won = now_won + (cash_hour1*5000)+(cash_hour2*500)+(cash_min1*50)+(cash_min2*5)+(cash_sec1-(cash_sec1-5))
			If tip_min2 = lotto_min1 And tip_min2 <> lotto_min2 Then now_won = now_won + (cash_hour1*5000)+(cash_hour2*500)+(cash_min1*50)+(cash_min2*5)+(cash_sec1-(cash_sec1-5))
			If tip_sec1 = lotto_min2 And tip_sec1 <> lotto_sec1 Then now_won = now_won + (cash_hour1*5000)+(cash_hour2*500)+(cash_min1*50)+(cash_min2*5)+(cash_sec1-(cash_sec1-5)) 
			If tip_sec2 = lotto_min1 And tip_sec2 <> lotto_sec2 Then now_won = now_won + (cash_hour1*5000)+(cash_hour2*500)+(cash_min1*50)+(cash_min2*5)+(cash_sec1-(cash_sec1-5))
			select_lotto = 2
			EndIf 
			
			WaitKey()
			
			Text 10,200,"Du erhlst "+now_won+" Sekunden dazu!"
			
			If KeyHit(28) Then
				acc_sec = acc_sec+now_won
				tip_hour1 = 0
				tip_hour2 = 0
				tip_min1 = 0
				tip_min2 = 0
				tip_sec1 = 0
				tip_sec2 = 0
				If now_won# >= 3600 Then won_hour# = won_hour#+((now_won# - now_won Mod 3600)/3600)
				If now_won# >= 60 Then won_min# = won_min#+((now_won# - now_won Mod 60)/60)
				won_sec# = won_sec#+now_won# Mod 60
				select_lotto = 0
				now_won = 0
				play_game = 0
				acc_hour = acc_hour-(cash_hour1*10+cash_hour2)
				acc_min = acc_min-(cash_min1*10+cash_min2)
				acc_sec = acc_sec-(cash_sec1*10+cash_sec2)
			EndIf 
  	 	
		End Select
		
		If KeyHit(68) Then game = 0 : number = 0
			
	End Select 
	EndIf 
	
If KeyHit(1) Then
	choice = 0
	SetFont font_menu
EndIf

End Function


Function TimeCounter()

If choice = 8 Then

	Select appchoice

	Case 0
	
	SetFont font_title
	Color 255,0,0
	Text 200,20,"Rechnen mit der Zeit",200,200
	SetFont font_menu
	
	Text 10,100,"Ewiger Kalender"
	Text 10,200,"Uhrzeit-Rechner"
	Text 250,100,"Planeten-Zeit"
	Text 250,200,"Zeitdilatation"
	
	Select number
		Case 0 : Rect 8,100,120,22,0
		If KeyHit(28) Then appchoice = 1
		Case 1 : Rect 8,200,128,22,0
		If KeyHit(28) Then appchoice = 2
		Case 2 : Rect 248,100,105,22,0
		If KeyHit(28) Then appchoice = 3
		Case 3 : Rect 248,200,104,22,0
		If KeyHit(28) Then appchoice = 4
	End Select 
	
	If KeyHit(200) Then
		If number > 0 Then
			number = number-1
		Else
			number = 3
		EndIf
	ElseIf KeyHit(208) Then
		If number < 3 Then
			number = number+1
		Else
			number = 0
		EndIf
	EndIf 
		

	Case 1
	
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Ewiger Kalender",200,200
		SetFont font_menu
		
		Text 200,70,"Mit dem Ewigen Kalender kannst du bestimmen,",200,200
		Text 200,90,"welcher Wochentag an einem bestimmten Datum",200,200
		Text 200,110,"gerade war.",200,200
		Text 200,140,"In der Readme.txt findest du einige his-",200,200
		Text 200,160,"torische Daten, deren Wochentage du bei-",200,200
		Text 200,180,"spielsweise herausfinden kannst!",200,200
		Text 200,220,"Drcke Enter, um zu starten!",200,200 
		
		If KeyHit(28) Then run = 1
		
		If run = 1 Then
		FlushKeys()
		Locate 0,260
		d = Input("Bitte Tag eingeben: ")
		m = Input("Monat: ")
		y = Input("Jahr: ")
		y1 = Int(Left(y,2))
		y2 = Int(Mid(y,3,2))
	
		If m = 1 Or m = 2 Then
			m = m+12
			If y2 = 0 Then
				y1 = y1-1
				y2 = 99
			ElseIf y2 <> 0 Then
				y2 = y2 - 1
			EndIf
		EndIf 
	
		date = (d+(((m+1)*26)/10)+y2+(y2/4)+(y1/4)-2*y1) Mod 7
	
		Select date
			Case 0 : Text 200,330,"Das war ein Samstag.",200,200
			Case 1 : Text 200,330,"Das war ein Sonntag.",200,200
			Case 2 : Text 200,330,"Das war ein Montag.",200,200
			Case 3 : Text 200,330,"Das war ein Dienstag.",200,200
			Case 4 : Text 200,330,"Das war ein Mittwoch.",200,200
			Case 5 : Text 200,330,"Das war ein Donnerstag.",200,200
			Case 6 : Text 200,330,"Das war ein Freitag.",200,200
		End Select
		
		WaitKey()
		run = 0
		FlushKeys()
		EndIf 
		
	If KeyHit(68) Then appchoice = 0 : number = 0
	
	
	Case 2
			
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Uhrzeit-Rechner",200,200
		SetFont font_menu
			
		Text 200,70,"Der Uhrzeit-Rechner kann Stunden, Minuten",200,200
		Text 200,90,"und Sekunden addieren und subtrahieren.",200,200
			
		Text 10,150,"Plus [W]"
		Text 100,150,"Minus [E]"
		
		Text 150,200,count_hour1,200,200
		Text 160,200,count_hour2,200,200
		Text 170,200,":",200,200
		Text 180,200,count_min1,200,200
		Text 190,200,count_min2,200,200
		Text 200,200,":",200,200
		Text 210,200,count_sec1,200,200
		Text 220,200,count_sec2,200,200
		
		Text 10,230,"Ergebnis:"
		If neg = 1 Then Text 135,230,"-"
		Text 150,230,(temp_hour1)
		Text 160,230,(temp_hour2)
		Text 170,230,":"
		Text 180,230,(temp_min1)
		Text 190,230,(temp_min2)
		Text 200,230,":"
		Text 210,230,(temp_sec1)
		Text 220,230,(temp_sec2)
		
		 
		
			If KeyHit(203) Then
				If number > 0 Then
				number = number - 1
				Else
				number = 5
				EndIf 
			ElseIf KeyHit(205) Then
				If number < 5 Then
				number = number + 1
				Else
				number = 0
				EndIf 
			EndIf 
			
			If temp_hour1 > 9 Then temp_hour = temp_hour-10
			
			If KeyHit(17) Then
				count_hour1 = (temp_hour1+count_hour1)
				count_hour2 = (temp_hour2+count_hour2)
				count_min1 = (temp_min1+count_min1)
				count_min2 = (temp_min2+count_min2)
				count_sec1 = (temp_sec1+count_sec1)
				count_sec2 = (temp_sec2+count_sec2)
				temp_hour1 = count_hour1
				temp_hour2 = count_hour2
				temp_min1 = count_min1
				temp_min2 = count_min2
				temp_sec1 = count_sec1
				temp_sec2 = count_sec2
				
				If temp_sec2 > 9 Then
					temp_val = temp_sec2
					temp_sec1 = temp_sec1 + Int(Left(temp_val,1))
					temp_sec2 = Int(Right(temp_val,1))
				ElseIf temp_sec1 > 5 Then
					temp_min2 = temp_min2+1
					temp_sec1 = temp_sec1-6
				ElseIf temp_min2 > 9 Then
					temp_val = temp_min2
					temp_min1 = temp_min1 + Int(Left(temp_val,1))
					temp_min2 = Int(Right(temp_val,1))
				ElseIf temp_min1 > 5 Then
					temp_hour2 = temp_hour2+1
					temp_min1 = temp_min1-6
				ElseIf temp_hour2 > 9 Then
					temp_val = temp_hour2
					temp_hour1 = temp_hour1 + Int(Left(temp_val,1))
					temp_hour2 = Int(Right(temp_val,1))
				ElseIf temp_hour1 > 9 Then
					temp_hour1 = temp_hour1-10
				EndIf
				
				count_hour1 = 0 : count_hour2 = 0 : count_min1 = 0 : count_min2 = 0 : count_sec1 = 0 : count_sec2 = 0
			ElseIf KeyHit(18) Then
					carry_sec2 = (temp_sec2-count_sec2)										
					temp_sec2 = carry_sec2
						If temp_sec2 < 0 Then
							temp_sec2 = 10+temp_sec2
							count_sec1 = count_sec1+1
						EndIf 
					carry_sec1 = (temp_sec1-count_sec1)	
					temp_sec1 = carry_sec1
						If temp_sec1 < 0 Then
							temp_sec1 = 6+temp_sec1
							count_min2 = count_min2+1
						EndIf 
					carry_min2 = (temp_min2-count_min2)
					temp_min2 = carry_min2
						If temp_min2 < 0 Then
							temp_min2 = 10+temp_min2
							count_min1 = count_min1+1
						EndIf
					carry_min1 = (temp_min1-count_min1)
					temp_min1 = carry_min1
						If temp_min1 < 0 Then
							temp_min1 = 6+temp_min1
							count_hour2 = count_hour2+1
						EndIf 
					carry_hour2 = (temp_hour2-count_hour2)
					temp_hour2 = carry_hour2
						If temp_hour2 < 0 Then
							temp_hour2 = 10+temp_hour2
							count_hour1 = count_hour1+1
						EndIf
					carry_hour1 = (temp_hour1-count_hour1)			
					temp_hour1 = carry_hour1
						If temp_hour1 < 0 Then
							neg = 1
							temp_hour1 = Abs(temp_hour1)
						EndIf  

				count_hour1 = 0 : count_hour2 = 0 : count_min1 = 0 : count_min2 = 0 : count_sec1 = 0 : count_sec2 = 0 
			EndIf 
			
			If temp_sec2 > 9 Then
				temp_sec1 = temp_sec1 + Left(temp_sec2,1)
				temp_sec2 = temp_sec2 Mod 10
			ElseIf temp_sec1 > 5 Then
				temp_min2 = temp_min2 + (temp_sec1 - (temp_sec1 Mod 10))
				temp_sec1 = temp_sec1-60
			ElseIf temp_min2 > 9 Then
				temp_min1 = temp_min1 + Left(temp_min2,1)
				temp_min2 = temp_min2 Mod 10
			ElseIf temp_min1 > 5 Then
				temp_hour2 = temp_hour2 + (temp_min1 - (temp_min1 Mod 10))
			ElseIf temp_hour2 > 9 Then
				temp_hour1 = temp_hour1 + Left(temp_hour2,1)
				temp_hour2 = temp_hour2 Mod 10
			EndIf 
		
		Select number
		
			Case 0
				Rect 145,210,10,2
				If KeyHit(200) And count_hour1 < 9 Then count_hour1 = count_hour1+1
				If KeyHit(208) And count_hour1 > 0 Then count_hour1 = count_hour1-1
			Case 1
				Rect 155,210,10,2
				If KeyHit(200) And count_hour2 < 9 Then count_hour2 = count_hour2+1
				If KeyHit(208) And count_hour2 > 0 Then count_hour2 = count_hour2-1
			Case 2
				Rect 175,210,10,2
				If KeyHit(200) And count_min1 < 9 Then count_min1 = count_min1+1
				If KeyHit(208) And count_min1 > 0 Then count_min1 = count_min1-1
			Case 3
				Rect 185,210,10,2
				If KeyHit(200) And count_min2 < 9 Then count_min2 = count_min2+1
				If KeyHit(208) And count_min2 > 0 Then count_min2 = count_min2-1
			Case 4
				Rect 205,210,10,2
				If KeyHit(200) And count_sec1 < 9 Then count_sec1 = count_sec1+1
				If KeyHit(208) And count_sec1 > 0 Then count_sec1 = count_sec1-1
			Case 5
				Rect 215,210,10,2
				If KeyHit(200) And count_sec2 < 9 Then count_sec2 = count_sec2+1
				If KeyHit(208) And count_sec2 > 0 Then count_sec2 = count_sec2-1
	
		End Select 
			
		If KeyHit(68) Then appchoice = 0 : number = 0
	
	Case 3
	
		;FlushKeys()
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Planeten-Zeit",200,200
		SetFont font_menu
		
		Text 10,100,"Mit diesem Tool kannst du dir ausrechnen, wie alt"
		Text 10,120,"du auf einem anderen Planeten wrst."
		
		;variables for planets
		Select planet1
			Case 1 : year1# = 87.969	: planetname1$ = "Merkur"
			Case 2 : year1# = 224.701	: planetname1$ = "Venus"
			Case 3 : year1# = 365.256	: planetname1$ = "Erde"
			Case 4 : year1# = 686.980	: planetname1$ = "Mars"
			Case 5 : year1# = 4328.9	: planetname1$ = "Jupiter"
			Case 6 : year1# = 10751.805	: planetname1$ = "Saturn"
			Case 7 : year1# = 30664.015	: planetname1$ = "Uranus"
			Case 8 : year1# = 60148.35	: planetname1$ = "Neptun"
		End Select
		
		Select planet2
			Case 1 : year2# = 87.969	: planetname2$ = "Merkur"
			Case 2 : year2# = 224.701	: planetname2$ = "Venus"
			Case 3 : year2# = 365.256	: planetname2$ = "Erde"
			Case 4 : year2# = 686.980	: planetname2$ = "Mars"
			Case 5 : year2# = 4328.9	: planetname2$ = "Jupiter"
			Case 6 : year2# = 10751.805	: planetname2$ = "Saturn"
			Case 7 : year2# = 30664.015	: planetname2$ = "Uranus"
			Case 8 : year2# = 60148.35	: planetname2$ = "Neptun"
		End Select 
		
		Text 10,150,"1. Planet: "+planetname1$+" ("+year1#+" Tage = 1 "+planetname1$+"-Jahr)"
		Text 10,170,"2. Planet: "+planetname2$+" ("+year2#+" Tage = 1 "+planetname2$+"-Jahr)"
		Text 10,190,"Drcke Enter, um den Rechner zu starten!"
		
		If KeyHit(203) Then
			If planetchoice = 0 Then
				If planet1 > 0 Then planet1 = planet1 -1
				If planet1 = 0 Then planet1 = 8
			ElseIf planetchoice = 1 Then
				If planet2 > 0 Then planet2 = planet2 -1
				If planet2 = 0 Then planet2 = 8
			EndIf 
		ElseIf KeyHit(205) Then
			If planetchoice = 0 Then
				If planet1 < 9 Then planet1 = planet1 + 1
				If planet1 = 9 Then planet1 = 1
			ElseIf planetchoice = 1 Then
				If planet2 < 9 Then planet2 = planet2 + 1
				If planet2 = 9 Then planet2 = 1
			EndIf
		EndIf 


		
		If KeyHit(200) Or KeyHit(208) Then planetchoice = 1-planetchoice
				
		If KeyHit(28) Then run = 1
		
		If run = 1 Then
			FlushKeys()
		
			Locate 10,220
			age1# = Input("Wie alt bist du? (in Jahren) ")
			
			age2# = age1#*(year1# / year2#)
			
			Text 20,240,"Wenn du auf dem Planeten "+planetname1$
			Text 20,260,age1#+" Jahre alt wrst, so wrst du auf dem"
			Text 20,280,"Planeten "+planetname2$+" "+age2#+" Jahre alt."
			WaitKey()
		
		run = 0
		EndIf 
		
		If KeyHit(68) Then appchoice = 0 : menuchoice = 0 : number = 0
		
	Case 4
	
		SetFont font_title
		Color 255,0,0
		Text 200,20,"Zeitdilatation",200,200
		SetFont font_menu
		
		Text 200,110,"Mit diesem Tool kannst du eine virtuelle",200,200
		Text 200,130,"Geschwindigkeit einstellen. Je schneller du dich",200,200
		Text 200,150,"bewegst, umso langsamer vergeht die Zeit fr dich",200,200
		Text 200,170,"in Bezug auf die Zeit auf der Erde.",200,200
		
		Text 20,210,"Virtuelle Geschwindigkeit: "+speed#+" km/s"
		Text 20,230,"Das sind "+((speed#/299792.458)*100)+"% der Lichtgeschwindigkeit."
		Text 20,250,"Fr dich vergeht die Zeit mit "+percent#+"% Erdzeit."
		Text 20,270,"Ein Erdjahr dauert fr dich "+dilatation#+" Tage."
		
		Text 20,330,"Hier siehst du deine Lngenkontraktion:"
		
		If KeyDown(203) And speed# > 0 Then speed# = speed#-50
		If KeyDown(205) And speed# < 299750 Then speed# = speed + 50
		
		dilatation# = (365.256 / Sqr(1-(speed#^2 / (299792.458)^2)) )
		
		percent# = (365.256 / dilatation#)*100
				
		Color 50,200,40
		Rect 20,350,360,45,1
		
		Color 180,30,30
		Rect 20,350,width#,45,1
		
		width# = (360 * Sqr(1-((speed#^2) / (299792.458)^2)))
		
		If KeyHit(68) Then appchoice = 0 : number = 0
			 
	End Select


If KeyHit(1) Then
	choice = 0
	appchoice = 0
EndIf 

EndIf 

End Function 