;=================================================================
; Name : bass_wma.bb
;=================================================================

; Additional config options
Const BASS_CONFIG_WMA_PRECHECK = $10100
Const BASS_CONFIG_WMA_PREBUF = $10101
Const BASS_CONFIG_WMA_ASX = $10102
Const BASS_CONFIG_WMA_BASSFILE = $10103
Const BASS_CONFIG_WMA_NETSEEK = $10104

; additional WMA sync type
Const BASS_SYNC_WMA_CHANGE = 1001

; additional BASS_StreamGetFilePosition WMA mode
Const BASS_FILEPOS_WMA_BUFFER = 1000

; Additional flags for use with BASS_WMA_EncodeOpen/File/Network/Publish
Const BASS_WMA_ENCODE_STANDARD = $2000
Const BASS_WMA_ENCODE_PRO = $4000
Const BASS_WMA_ENCODE_24BIT = $8000
Const BASS_WMA_ENCODE_SCRIPT = $20000

; Additional flag for use with BASS_WMA_EncodeGetRates
Const BASS_WMA_ENCODE_RATES_VBR= $10000

; WMENCODEPROC "type" values
Const BASS_WMA_ENCODE_HEAD = 0
Const BASS_WMA_ENCODE_DATA = 1
Const BASS_WMA_ENCODE_DONE = 2

; BASS_WMA_EncodeSetTag "type" values
Const BASS_WMA_TAG_ANSI = 0
Const BASS_WMA_TAG_UNICODE = 1
Const BASS_WMA_TAG_UTF8 = 2

; BASS_CHANNELINFO type
Const BASS_CTYPE_STREAM_WMA = $10300
Const BASS_CTYPE_STREAM_WMA_MP3 = $10301

; Additional BASS_ChannelGetTags type
Const BASS_TAG_WMA = 8

;~IDEal Editor Parameters:
;~C#Blitz3D