Graphics 600,200,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Type balls
	Field x#, y#, rad
	Field fx#, fy#
End Type

timer = CreateTimer(60)

For A = 0 To 15
	ball.balls = New balls
	ball\x = Rand(25, 575):ball\y = Rand(25, 175):ball\rad = Rand(15, 30)
	ball\fx = 0:ball\fy = -1
Next

rt = CreateImage(600,200):MaskImage rt, 255, 255, 255

Dim T$(6)

bigfont = LoadFont("Times New Roman", 150)

While Not KeyHit(1)
	Cls
	mforce# = Sqr(Float(Abs((mx-MouseX())*2 + (my-MouseY())*2)))
	If mforce# < 0.75 mforce = 0.75
	If mforce# > 5 mforce = 5
	mx = MouseX()
	my = MouseY()

	Temp$ = CurrentTime()
	T(0) = Left(Temp$, 1)
	T(1) = Mid(Temp$, 2, 1)
	T(2) = Mid(Temp$, 4, 1)
	T(3) = Mid(Temp$, 5, 1)
	T(4) = Mid(Temp$, 7, 1)
	T(5) = Mid(Temp$, 8, 1)
	
	SetBuffer ImageBuffer(rt)
	Cls
	SetFont bigfont
	Color 5, 5, 5
	Text 100, 100, T(0)+T(1), 1, 1
	Text 300, 100, T(2)+T(3), 1, 1
	Text 500, 100, T(4)+T(5), 1, 1
	Text 200, 100, ":", 1, 1
	Text 400, 100, ":", 1, 1

	Color  51,  51,  51:Oval mx-10, my-10, 20, 20
	Color 102, 102, 102:Oval mx-9, my-9, 18, 18
	Color 153, 153, 153:Oval mx-8, my-8, 16, 16
	Color 204, 204, 204:Oval mx-7, my-7, 14, 14
	Color 255, 255, 255:Oval mx-6, my-6, 12, 12

	For ball.balls = Each balls
		ball\fx = ball\fx
		ball\fy = ball\fy
		ball\x = ball\x + ball\fx
		ball\y = ball\y + ball\fy
		
		If ball\x > 600-ball\rad Or ball\x < ball\rad
			ball\fx = -ball\fx*0.99
			ball\x = ball\x + ball\fx
			ball\y = ball\y + ball\fy
			If ball\x > 600-ball\rad
				ball\x = 600-ball\rad
			ElseIf ball\x < ball\rad
				ball\x = ball\rad
			EndIf
			ball\fx = ball\fx*0.99
		EndIf
		If ball\y > 200-ball\rad Or ball\y < ball\rad
			ball\fy = -ball\fy*0.99
			ball\x = ball\x + ball\fx
			ball\y = ball\y + ball\fy
			If ball\y > 200-ball\rad
				ball\y = 200-ball\rad
			ElseIf ball\y < ball\rad
				ball\y = ball\rad
			EndIf
			ball\fx = ball\fx*0.99
		EndIf
		
		dist# = Sqr((ball\x-mx)^2 + (ball\y-my)^2)
		If dist# < ball\rad + 10
			winkel# = (ATan2(ball\y-my, ball\x-mx) +180) Mod 360
			ball\fx# = -Cos(winkel#)*mforce
			ball\fy# = -Sin(winkel#)*mforce
			ball\x = ball\x + ball\fx
			ball\y = ball\y + ball\fy
		EndIf
		
		For ball2.balls = Each balls
			If ball2 <> ball
				dist# = Sqr((ball\x-ball2\x)^2 + (ball\y-ball2\y)^2)
				If dist# < ball\rad + ball2\rad
					winkel# = (ATan2(ball\y-ball2\y, ball\x-ball2\x) +180) Mod 360
					ball\fx# = -Cos(winkel#)*min(max(Sqr(Abs(ball\fx -ball2\fx)^2), 2), 0.25)
					ball\fy# = -Sin(winkel#)*min(max(Sqr(Abs(ball\fy -ball2\fy)^2), 2), 0.25)
					ball2\fx# = Cos(winkel#)*min(max(Sqr(Abs(ball\fx -ball2\fx)^2), 2), 0.25)
					ball2\fy# = Sin(winkel#)*min(max(Sqr(Abs(ball\fy -ball2\fy)^2), 2), 0.25)
					ball\x = ball\x + ball\fx
					ball\y = ball\y + ball\fy
					ball2\x = ball2\x + ball2\fx
					ball2\y = ball2\y + ball2\fy
					dist# = Sqr((ball\x-ball2\x)^2 + (ball\y-ball2\y)^2)
				EndIf
			EndIf
		Next
		Color  51,  51,  51:Oval ball\x-ball\rad, ball\y-ball\rad, ball\rad*2, ball\rad*2
		Color 102, 102, 102:Oval ball\x-ball\rad+1, ball\y-ball\rad+1, (ball\rad-1)*2, (ball\rad-1)*2
		Color 153, 153, 153:Oval ball\x-ball\rad+2, ball\y-ball\rad+2, (ball\rad-2)*2, (ball\rad-2)*2
		Color 204, 204, 204:Oval ball\x-ball\rad+3, ball\y-ball\rad+3, (ball\rad-3)*2, (ball\rad-3)*2
		Color 255, 255, 255:Oval ball\x-ball\rad+4, ball\y-ball\rad+4, (ball\rad-4)*2, (ball\rad-4)*2
	Next
	SetBuffer BackBuffer()
	Rect 0, 0, 600, 200
	
	SetFont bigfont
	Color 0, 0, 0
	Text 100, 100, T(0)+T(1), 1, 1
	Text 300, 100, T(2)+T(3), 1, 1
	Text 500, 100, T(4)+T(5), 1, 1
	Text 200, 100, ":", 1, 1
	Text 400, 100, ":", 1, 1
	
	DrawImage rt, 0, 0
	
	Color 255, 255, 255
	Flip 0
	WaitTimer timer
Wend

Function max#(a#,b#)
	If b > a Return a
	Return b
End Function

Function min#(a#, b#)
	If b > a Return b
	Return a
End Function