SuperStrict
Graphics 490,60,0,30

SetImageFont(LoadImageFont("gfx/Arial.ttf",13))
AppTitle="Textuhr"

Repeat
	Cls
	If KeyHit(KEY_P) Then Cls; DrawText "Pause",490/2-TextWidth("pause")/2,60/2-TextHeight("pause")/2;Flip;WaitKey
	Local Date:String=CurrentDate()
	Local Time:String=CurrentTime()

	Local Stunde:Int=Int(Left(Time,Instr(Time,":")))
	Time=Mid(Time,Instr(Time,":")+1)
	Local Minute:Int=Int(Left(Time,Instr(Time,":")))
	Time=Mid(Time,Instr(Time,":")+1)
	Local Sekunde:Int=Int(Time)
	
	Local Tag:Int=Int(Left(Date,Instr(Date," ")))
	Date=Mid(Date,Instr(Date," ")+1)
	Local Monat:String=Left(Date,Instr(Date," "))
	Date=Mid(Date,Instr(Date," ")+1)
	
	Local Jahr:Int=Int(Date)
	
	DrawText "Es ist "+IntToText(Stunde)+" Uhr  "+IntToText(Minute)+" und "+IntToText(Sekunde+1)+" Sekunden.",10,10
	DrawText "Heute ist der "+IntToText(Tag,1)+", "+IntToMonth(Monat)+" und das Jahr "+IntToText(Jahr)+".",10,30
	
	'Nun gehts an die Darstellung
	SetColor 230,230,230
	DrawOval GraphicsWidth()-60,0,60,60
	SetColor 255,0,0
	DrawOval GraphicsWidth()-30-5,30-5,10,10
	DrawLine GraphicsWidth()-30,30,GraphicsWidth()-30+Cos((Float(Sekunde)/60.0)*360.0-90)*30.0,30+Sin((Float(Sekunde)/60.0)*360.0-90)*30.0
	DrawLine GraphicsWidth()-30,30,GraphicsWidth()-30+Cos((Float(Minute)/60.0)*360.0-90)*25.0,30+Sin((Float(Minute)/60.0)*360.0-90)*25.0
	DrawLine GraphicsWidth()-30,30,GraphicsWidth()-30+Cos((Float(Stunde)/60.0)*360.0-90)*20.0,30+Sin((Float(Stunde)/60.0)*360.0-90)*20.0
	SetColor 255,255,255
	SetClsColor (Float(Sekunde)/60.0)*255.0,(Float(Minute)/60.0)*255.0,(Float(Stunde)/60.0)*255.0
	Flip
Until KeyHit(KEY_ESCAPE) Or AppTerminate()

Function IntToMonth:String(Monat:String)
	Local MonName:String
	Monat=Trim(Lower(Monat))
	Select Monat
		Case "mon"
			MonName="Jnner"
		Case "jan"
			MonName="Februar"
		Case "mar"
			MonName="Mrz"
		Case "apr"
			MonName="April"
		Case "may"
			MonName="Mai"
		Case "jun"
			MonName="Juni"
		Case "jul"
			MonName="Juli"
		Case "aug"
			MonName="August"
		Case "sep"
			MonName="September"
		Case "oct"
			MonName="Oktober"
		Case "nov"
			MonName="November"
		Case "dec"
			MonName="Dezember"
	End Select
	Return MonName
End Function

Function LowerAll:String(Text:String)
	Text=Lower(Text)
	'32
	Local Letter:String=Mid(Text,1,1)
	
	Text=Mid(Text,2)
	Letter=Chr(Asc(Letter)-32)
	Text=Letter+text
	Return text
End Function

Function IntToText:String(Value:Int,dd:Byte=0)
	Local Val:String=RSet(String(Value),4)
	val=Replace(val," ","0")
	
	Local Text:String
	Local FoundVal:String
	
	For Local i:Int=Len(Val) To 1 Step -1
		Select i
			Case 4 'Einer
				?Debug
					Print "Debug: Einer gefunden"
				?
				Text:+Einer(Int(Mid(String(Val),i,1)))
				FoundVal:+Mid(String(Val),i,1)
			Case 3 'Zehner
				?Debug
					Print "Debug: Zehner gefunden"
				?
				If Mid(String(Val),i,1)<>"0"
					FoundVal:+Mid(String(Val),i,1)
					Select FoundVal
						Case "11"
							Text="Elf"
						Case "21"
							Text="Zwlf"
						Case "31"
							Text="Dreizehn"
						Case "41"
							Text="Vierzehn"
						Case "51"
							Text="Fnfzehn"
						Case "61"
							Text="Sechszehn"
						Case "71"
							Text="Siebzehn"
						Case "81"
							Text="Achtzehn"
						Case "91"
							Text="Neunzehn"
						Default
							If Left(foundval,1)<>"0"
								Text:+"und"
							EndIf
							Text:+Zehner(Int(Mid(String(Val),i,1)))
					End Select
				Else
					If Left(Foundval,1)="1" And (Mid(foundval,2,1)="0" Or Len(foundval)=1)
						Text="Eins"
					EndIf
				EndIf
			Case 2 'Hunderter
				?Debug
					Print "Debug: Hunderter gefunden"
				?
				If Mid(String(Val),i,1)<>"0"
					Text=hunderter(Int(Mid(String(Val),i,1)))+Text
					FoundVal:+Mid(String(Val),i,1)
				EndIf
			Case 1 'tausender
				?Debug
					Print "Debug: Tausender gefunden"
				?
				If Mid(String(Val),i,1)<>"0"
					Text=Tausender(Int(Mid(String(Val),i,1)))+Text
					FoundVal:+Mid(String(Val),i,1)
				EndIf
		End Select
		
	Next
	If Left(Foundval,1)="1" And Len(foundval)=1
		Text="Eins"
	EndIf
	If Value=0 Then Text="Null"
	'Text=Replace(Text,"ZweiZehn","")
	If dd
		Select Text
			Case "Eins"
				Text="Erste"
			Case "Drei"
				Text="Dritte"
			Default
				Text:+"te"
		End Select
	EndIf
	Text=lowerall(text)
	Return Text
End Function

Function Einer:String(Val:Int)
	Local Text:String

	Select Val
		Case 0
			'Text="Null"
		Case 1
			Text="Ein"
		Case 2
			text="Zwei"
		Case 3
			text="Drei"	
		Case 4
			text="Vier"
		Case 5
			text="Fnf"
		Case 6
			text="Sechs"
		Case 7
			text="Sieben"
		Case 8
			text="Acht"
		Case 9
			text="Neun"
	End Select
	
	Return text
End Function
Function Zehner:String(Val:Int)
	Local Text:String

	Select Val
		Case 0
			'Text="Null"
		Case 1
			Text="Zehn"
		Case 2
			text="Zwanzig"
		Case 3
			text="Dreiig"	
		Case 4
			text="Vierzig"
		Case 5
			text="Fnfzig"
		Case 6
			text="Sechszig"
		Case 7
			text="Siebzig"
		Case 8
			text="Achtzig"
		Case 9
			text="Neunzig"
	End Select
	
	Return text
End Function
Function Hunderter:String(Val:Int)
	Local Text:String

	Select Val
		Case 0
			'Text="Null"
		Case 1
			Text="Einhundert"
		Case 2
			text="Zweihundert"
		Case 3
			text="Dreihundert"	
		Case 4
			text="Vierhundert"
		Case 5
			text="Fnfhundert"
		Case 6
			text="Sechshundert"
		Case 7
			text="Siebenhundert"
		Case 8
			text="Achthundert"
		Case 9
			text="Neunhundert"
	End Select
	
	Return text
End Function

Function Tausender:String(Val:Int)
	Local Text:String

	Select Val
		Case 0
			'Text="Null"
		Case 1
			Text="EinTausend"
		Case 2
			text="Zweitausend"
		Case 3
			text="Dreitausend"	
		Case 4
			text="Viertausend"
		Case 5
			text="Fnftausend"
		Case 6
			text="Sechstausend"
		Case 7
			text="Siebentausend"
		Case 8
			text="Achttausend"
		Case 9
			text="Neuntausend"
	End Select
	
	Return text
End Function
