Const Size=0	;Ini-Constants
Const Space=1
Const Scale=2
Const FPS=3
Const GlowD=4
Const GSize=5

Const XUp=0,XDown=1	;Constants for the outer Cube+Shaow-Plane
Const YUp=2,YDown=3
Const ZUp=4,ZDown=5
Const ShadowPlane=6

Const GWL_EXSTYLE = -20		;Windows Api Consts needed for Desktop cliping
Const GWL_HWNDPARENT = -8
Const GWL_STYLE = -16
Const WS_EX_TOOLWINDOW = $80
Const WS_CHILD = $40000000
Const HWND_TOPMOST  		= -1
Const HWND_BOTTOM = 1
Const SW_SHOW = 5
Const SW_HIDE = 0
Const SWP_NOACTIVATE = $10
Const SWP_NOSIZE = $1
Const SWP_SHOWWINDOW = $40
Const SWP_NOMOVE  			= $2
Const SPI_GETWORKAREA=48
Const SPI_SETWORKAREA=47


Type Api_Rect
	Field Left
	Field Top
	Field Right
	Field Bottom
End Type

Dim Ini(6)		;Ini-Vars Dim
Ini(Size)=10
Ini(Space)=1
Ini(Scale)=1
Ini(FPS)=60
Ini(GlowD)=5
Ini(GSize)=400
Global XOrientation=2,YOrientation=2
Sub_ReadIni()
Dim Cubes(Ini(Size),Ini(Size),Ini(Size),4)	;Dim for the Inner Cube
Dim OuterCube(Ini(Size),Ini(Size),7)		;Dim for the Outer Cube+Shadow-Plane
Dim Skala(4,32)
Dim Table#(Ini(Size),Ini(FPS)+1)			;Dim for Precalculate Vars


Const C_Hour=0	;Consts for GetR/G/B Functions

Global Timer,Camera
Global SingleSurfEntity
Global SingleSurface
Global SingleSurfTexture
Global Pivot,Cube,CubeSurf
Global CubeTexture,BackgroundTexture
Global Background,ShadowTexture
Global Shadow,ShadowSurf,SkalaEntity
Global SkalaTexture,SkalaSurf
Global DeskRect.Api_Rect=New Api_Rect
Global TempRect.Api_Rect=New Api_Rect

Sub_Clip2Desktop() ;Wanted to have it in the Init Sub but Graphics3d has to be Executed within this Function so I placed it here

SetBuffer BackBuffer()

Sub_Init()	;Graphics Initialization. Seting up the szene and so on...

Local Counter,Mode,Time
Local X,Y,Z,Tmp#,R,G,B,C,D,E,HourEffect#,CT$
Local OldValue,tmp2#,Changed

;[Block] Mainlop
While Not IsKeyPressed($1B)
	
	TurnEntity Pivot,0.1,0.3,0.2 ;Turning the Cubes
	CT=CurrentTime()
	If Mode=-1 Then		;HourEffect Glow
		OldValue=HourEffect
		HourEffect=(HourEffect+360/(Ini(GlowD)*Ini(FPS))) Mod 360
		
		If HourEffect<OldValue Then ;this is just for beeing on the save side that the Effect stops when 2 Minutes have passed...
			HourEffect=0	;... couse we all know how unexact Blitz-Floats can be ;)
		EndIf
		
		Time=Int(Left(CT,2))
		Tmp#=(1+Sin(HourEffect-90))/2
		R=GetR(C_Hour,Time)*Tmp
		G=GetG(C_Hour,Time)*Tmp
		B=GetB(C_Hour,Time)*Tmp
		For X=0 To (Ini(Size)-1)
			If X<2 Then
				tmp2#=128.0+64.0*(1+Sin#(360*Float(Counter)/Float(Ini(FPS))-90))
				VertexColor(SkalaSurf,Skala(1+X,Time+4),128+127*Tmp,128+127*Tmp,128+127*Tmp)
				VertexColor(SkalaSurf,Skala(1+X,Time+3),128,128,128)
			EndIf
			For Y=0 To (Ini(Size)-1)
				C=R+G
				D=R+B
				E=G+B
				If C>255 Then
					D=D-(C-255)
					E=E-(C-255)
					C=255
				EndIf
				If D>255 Then
					C=C-(D-255)
					E=E-(D-255)
					D=255
				EndIf
				If E>255 Then
					C=C-(E-255)
					E=E-(E-255)
					E=255
				EndIf
				
				VertexColor(CubeSurf,OuterCube(Y,X,XUp),R,G,B)
				VertexColor(CubeSurf,OuterCube(Y,X,XDown),R,G,B)
				VertexColor(CubeSurf,OuterCube(Y,X,YUp),R,G,B)
				VertexColor(CubeSurf,OuterCube(Y,X,YDown),R,G,B)
				VertexColor(CubeSurf,OuterCube(X,Y,ZDown),R,G,B)
				VertexColor(CubeSurf,OuterCube(X,Y,ZUp),R,G,B)
				
				
				VertexColor(ShadowSurf,OuterCube(X,Y,ShadowPlane),255-E,255-D,255-C)
				
				For Z=0 To (Ini(Size)-1)
					
					VertexColor(SingleSurface,Cubes(X,Y,Z,0),R,G,B)
					VertexColor(SingleSurface,Cubes(X,Y,Z,1),R,G,B)
					VertexColor(SingleSurface,Cubes(X,Y,Z,2),R,G,B)
					VertexColor(SingleSurface,Cubes(X,Y,Z,3),R,G,B)
				Next
			Next
		Next
	ElseIf Mode=0		;Hours Flash / X-Flash
		Time=Int(Left(CT,2))
		For X=0 To (Ini(Size)-1)
			If X<2 Then
				tmp2#=128.0+64.0*(1+Sin#(360*Float(Counter)/Float(Ini(FPS))-90))
				VertexColor(SkalaSurf,Skala(1+X,Time+4),tmp2,tmp2,tmp2)
				VertexColor(SkalaSurf,Skala(1+X,Time+3),128,128,128)
			EndIf
			For Y=0 To (Ini(Size)-1)
				
				Tmp=Table(Y,Counter) ;Outer Cube
				
				R=GetR(C_Hour,Time)*Tmp#
				G=GetG(C_Hour,Time)*Tmp#
				B=GetB(C_Hour,Time)*Tmp#
				C=B
				D=G
				B=B+R
				G=G+R
				R=C
				G=G+C
				B=B-C
				G=G-D
				R=R+D
				B=B+D
				If R>255 Then
					B=B-(R-255)
					G=G-(R-255)
					R=255
				EndIf
				If G>255 Then
					B=B-(G-255)
					R=R-(G-255)
					G=255
				EndIf
				If B>255 Then
					R=R-(B-255)
					G=G-(B-255)
					B=255
				EndIf
				R=255-R
				G=255-G
				B=255-B
				VertexColor(CubeSurf,OuterCube(Y,X,XUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(Y,X,XDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(Y,X,YUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(Y,X,YDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				Tmp=Table(0,Counter)
				VertexColor(CubeSurf,OuterCube(X,Y,ZDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				Tmp=Table(Ini(Size)-1,Counter)
				VertexColor(CubeSurf,OuterCube(X,Y,ZUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				
				
				VertexColor(ShadowSurf,OuterCube(Y,X,ShadowPlane),R,G,B)
				
				
				
				For Z=0 To (Ini(Size)-1)
					Tmp#=Table#(X,Counter)
					R=GetR(C_Hour,Time)
					G=GetG(C_Hour,Time)
					B=GetB(C_Hour,Time)
					VertexColor(SingleSurface,Cubes(X,Y,Z,0),R*Tmp#,G*Tmp#,B*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,1),R*Tmp#,G*Tmp#,B*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,2),R*Tmp#,G*Tmp#,B*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,3),R*Tmp#,G*Tmp#,B*Tmp#)
				Next
			Next
		Next
	ElseIf Mode=1		;Minutes Flash / Y-Flash
		Time=Int(Mid(CT,4,2))/2.5
		For X=0 To (Ini(Size)-1)
			If X<2 Then
				tmp2#=128.0+64.0*(1+Sin#(360*Float(Counter)/Float(Ini(FPS))-90))
				VertexColor(SkalaSurf,Skala(1+X,Time+4),tmp2,tmp2,tmp2)
				VertexColor(SkalaSurf,Skala(1+X,Time+3),128,128,128)
			EndIf
			For Y=0 To (Ini(Size)-1)
				
				Tmp=Table(Y,Counter)
				
				R=GetR(C_Hour,Time)*Tmp#
				G=GetG(C_Hour,Time)*Tmp#
				B=GetB(C_Hour,Time)*Tmp#
				C=B
				D=G
				B=B+R
				G=G+R
				R=C
				G=G+C
				B=B-C
				G=G-D
				R=R+D
				B=B+D
				If R>255 Then
					B=B-(R-255)
					G=G-(R-255)
					R=255
				EndIf
				If G>255 Then
					B=B-(G-255)
					R=R-(G-255)
					G=255
				EndIf
				If B>255 Then
					R=R-(B-255)
					G=G-(B-255)
					B=255
				EndIf
				R=255-R
				G=255-G
				B=255-B
				VertexColor(CubeSurf,OuterCube(X,Y,YUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(X,Y,YDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(X,Y,ZUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(X,Y,ZDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				Tmp=Table(0,Counter)
				VertexColor(CubeSurf,OuterCube(X,Y,XDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				Tmp=Table(Ini(Size)-1,Counter)
				VertexColor(CubeSurf,OuterCube(X,Y,XUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				
				
				VertexColor(ShadowSurf,OuterCube(X,Y,ShadowPlane),R,G,B)
				
				For Z=0 To (Ini(Size)-1)
					Tmp=Table(Y,Counter)
					VertexColor(SingleSurface,Cubes(X,Y,Z,0),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,Float(GetB(C_Hour,Time))*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,1),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,Float(GetB(C_Hour,Time))*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,2),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,Float(GetB(C_Hour,Time))*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,3),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,Float(GetB(C_Hour,Time))*Tmp#)
				Next
			Next
		Next
	ElseIf Mode=2		;Seconds Flash / Z-Flash
		Time=Int(Mid(CT,7,2))/2.5
		For X=0 To (Ini(Size)-1)
			If X<2 Then
				tmp2#=128.0+64.0*(1+Sin#(360*Float(Counter)/Float(Ini(FPS))-90))
				VertexColor(SkalaSurf,Skala(1+X,Time+4),tmp2,tmp2,tmp2)
				VertexColor(SkalaSurf,Skala(1+X,Time+3),128,128,128)
			EndIf
			For Y=0 To (Ini(Size)-1)
				
				Tmp=Table(Y,Counter)
				
				R=GetR(C_Hour,Time)*Tmp#
				G=GetG(C_Hour,Time)*Tmp#
				B=GetB(C_Hour,Time)*Tmp#
				C=B
				D=G
				B=B+R
				G=G+R
				R=C
				G=G+C
				B=B-C
				G=G-D
				R=R+D
				B=B+D
				If R>255 Then
					B=B-(R-255)
					G=G-(R-255)
					R=255
				EndIf
				If G>255 Then
					B=B-(G-255)
					R=R-(G-255)
					G=255
				EndIf
				If B>255 Then
					R=R-(B-255)
					G=G-(B-255)
					B=255
				EndIf
				R=255-R
				G=255-G
				B=255-B
				VertexColor(CubeSurf,OuterCube(Y,X,ZUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(Y,X,ZDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(X,Y,XUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				VertexColor(CubeSurf,OuterCube(X,Y,XDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				Tmp=Table(Ini(Size)-1,Counter)
				VertexColor(CubeSurf,OuterCube(Y,X,YUp),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				Tmp=Table(0,Counter)
				VertexColor(CubeSurf,OuterCube(Y,X,YDown),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,GetB(C_Hour,Time)*Tmp#)
				
				
				VertexColor(ShadowSurf,OuterCube((Ini(Size)-1)-Y,X,ShadowPlane),R,G,B)
				
				For Z=0 To (Ini(Size)-1)
					Tmp=Table(Z,Counter)
					VertexColor(SingleSurface,Cubes(X,Y,Z,0),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,Float(GetB(C_Hour,Time))*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,1),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,Float(GetB(C_Hour,Time))*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,2),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,Float(GetB(C_Hour,Time))*Tmp#)
					VertexColor(SingleSurface,Cubes(X,Y,Z,3),GetR(C_Hour,Time)*Tmp#,GetG(C_Hour,Time)*Tmp#,Float(GetB(C_Hour,Time))*Tmp#)
				Next
			Next
		Next
	ElseIf Mode=3
		api_SystemParametersInfo(SPI_GETWORKAREA,0,TempRect.Api_Rect,0)
		If TempRect\Bottom<>DeskRect\Bottom Then
			Changed=1
			DeskRect\Bottom=TempRect\Bottom
		EndIf
		If TempRect\Top<>DeskRect\Top Then
			Changed=1
			DeskRect\Top=TempRect\Top
		EndIf
		If TempRect\Right<>DeskRect\Right Then
			Changed=1
			DeskRect\Right=TempRect\Right
		EndIf
		If TempRect\Left<>DeskRect\Left Then
			Changed=1
			DeskRect\Left=TempRect\Left
		EndIf
		
		If Changed=1 Then
			Changed=0
			RelocateWindow()
		EndIf
	EndIf
	
	RenderWorld()
	
	Flip 0
	WaitTimer Timer
	Counter=Counter+1	;Counting to FPS, just a way to avoid Millisecs()... and a bad one, but it doesn't matter because it's for the effects only, not for the color wich indicates the time so...
	If Counter>(Ini(FPS)-1) Then
		Counter=0
		If Int(Mid(CT,4,2))<2 Or HourEffect>0 Then ;During the first 2 Minutes of an hour or if the Effect is still running...
			Mode=-1 ;Full-Hour Glow-Effect-Mode
		Else
			Mode=(Mode+1) Mod 5 ;Mode ranges from 0 to 4 so it gonna be 2 secs pause between z- and x-Flash.
		EndIf
	EndIf
Wend
;[End Block]

Sub_DeInit() ;Deleting the Meshs etc
End



Function Sub_Init() ; Loads all the Graphics Sh.....y..ny things
	
	Local Fn_X,Fn_Y,Fn_Z,Fn_Tmp=Ini(Space)*(Ini(Size)-1)/2,Fn_Quad,Fn_hdc,Fn_bgr,Fn_r,Fn_g,Fn_b
	Local Fn_TSize=32,Fn_PD
	Repeat
		If Ini(GSize)>Fn_TSize Then
			Fn_TSize=Fn_TSize*2
		Else
			Exit
		EndIf
	Forever
	BackgroundTexture=CreateTexture(Fn_TSize,Fn_TSize) ;geting the Windows active Wallpaper
	Fn_hdc=api_GetDC(SystemProperty("AppHWND"))
	Fn_PD=PaintDesktop(Fn_hdc)
	If Not Fn_PD=0 Then
		SetBuffer TextureBuffer(BackgroundTexture)
		ClsColor 255,0,255
		Cls
		LockBuffer TextureBuffer(BackgroundTexture)
		Delay 1000
		For Fn_X=0 To (Ini(GSize)-1)
			PaintDesktop(Fn_hdc)
		;Delay 10
			For Fn_Y=0 To (Ini(GSize)-1)
				
				Fn_bgr=api_GetPixel(Fn_hdc,Fn_X,Fn_Y)
				Fn_r=Fn_bgr And  $0000FF
				Fn_g=(Fn_bgr And $00FF00)/$100
				Fn_b=(Fn_bgr And $FF0000)/$10000
				WritePixelFast(Fn_X,Fn_Y,Fn_r*$10000+Fn_g*$100+Fn_b,TextureBuffer(BackgroundTexture))
			Next
		Next
		UnlockBuffer TextureBuffer(BackgroundTexture)
		SetBuffer BackBuffer()
	EndIf
	api_SetWindowPos(SystemProperty("AppHWND"),HWND_BOTTOM,0,0,0,0,SWP_NOSIZE Or SWP_NOMOVE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW)
	
	Camera=CreateCamera()
	
	
	Background=CreateQuad()	;Setting up the Background Mesh
	FlipMesh Background
	EntityFX Background,1
	ScaleEntity Background,Fn_TSize,Fn_TSize,1
	PositionEntity Background,Fn_TSize-Ini(GSize)-1,-Fn_TSize+Ini(GSize)+1,Ini(GSize)
	EntityTexture Background,BackgroundTexture,0,1
	
	ShadowTexture=LoadTexture("gfx/Shadow.png",3) ;Same thing for the Shadow... Actually it could be completely disabled, but the doesn't look good on a non-black ground...
	Shadow=CreateSegmentedPlane(Ini(Size),Ini(Size),1)
	FlipMesh Shadow
	ScaleEntity Shadow,Ini(GSize),Ini(GSize),1
	PositionEntity Shadow,0,0,Ini(GSize)-1
	EntityTexture Shadow,ShadowTexture
	ShadowSurf=GetSurface(Shadow,1)
	EntityFX Shadow,3
	
	Pivot=CreatePivot()	;This Pivot was needed in a previous version, could be removed...
	
	SingleSurfEntity=CreateMesh(Pivot)	;Setting Up the Inner-Cubes Mesh
	SingleSurface=CreateSurface(SingleSurfEntity)
	SingleSurfTexture=LoadTexture("gfx/Light.png",3)
	EntityTexture SingleSurfEntity,SingleSurfTexture
	EntityFX SingleSurfEntity,3
	EntityBlend SingleSurfEntity,3
	
	Cube=CreateSegmentedCube(Ini(Size)) ;Setting Up the Outer-Cube
	CubeSurf=GetSurface(Cube,1)
	EntityParent(Cube,Pivot)
	ScaleEntity Cube,Ini(Space)*(Ini(Size)+2)/2,Ini(Space)*(2+Ini(Size))/2,Ini(Space)*(2+Ini(Size))/2
	CubeTexture=LoadTexture("gfx/Holocron.png",3)
	EntityTexture Cube,CubeTexture
	EntityFX Cube,3
	
	Timer=CreateTimer(Ini(FPS)) ;Maintimer( and...the only one :] )
	
	For Fn_X=0 To Ini(Size)-1	;Here all the little shiny plates are created. they point at the camera right here in the code, but later the Pivot is going to be moved...
		For Fn_Y=0 To Ini(Size)-1	;... This causes all the plates to 'look' to the center of the cube, would need a nother Function like PointEntity for SingleSurface...
			For Fn_Z=0 To Ini(Size)-1	;... But this would only mean Performance-Loss and it's looking good that way so... nevermind.
				Fn_Quad=CreateQuad()
				ScaleEntity Fn_Quad,Ini(Scale),Ini(Scale),1
				PositionEntity Fn_Quad,Fn_X*Ini(Space)-Fn_Tmp,Fn_Y*Ini(Space)-Fn_Tmp,Fn_Z*Ini(Space)-Fn_Tmp
				PointEntity Fn_Quad,Camera
				AddToSurface(Fn_Quad,SingleSurface,SingleSurfEntity,Fn_X,Fn_Y,Fn_Z)
				FreeEntity Fn_Quad
			Next
		Next
	Next
	
	For Fn_X=0 To (Ini(FPS)-1) ;Precalculation. Those Values are needed a lot in the Mainloop so I precalculate them to avoid Performance-Loss.
		For Fn_Y=0 To (Ini(Size)-1)
			Table(Fn_Y,Fn_X)=Sin(360.0*Float(Fn_X)/Float(Ini(FPS))-90.0*Float(Fn_Y)/(Float(Ini(Size))-1.0))
		Next
	Next
	PositionEntity Pivot,0,0,Sqr(((Ini(Space)*(Ini(Size)+2))^2)*2) ;Moves the SingleSurf.Entity + the Outer-Cube... as I mentioned earlier, the Pivot isn't needed anymore... 
	
	SkalaEntity=CreateSegmentedPlane(4,32,2)
	FlipMesh SkalaEntity
	SkalaSurf=GetSurface(SkalaEntity,1)
	SkalaTexture=CreateTexture(32,32)
	SetBuffer TextureBuffer(SkalaTexture)
	LockBuffer TextureBuffer(SkalaTexture)
	Color 255,255,255
	Rect 0,0,4,32,1
	Rect 0,0,32,4,1
	Rect 28,0,5,32,1
	Rect 0,28,32,5,1
	For Fn_Y=4 To 27
		Color GetR(C_Hour,Fn_Y-4),GetG(C_Hour,Fn_Y-4),GetB(C_Hour,Fn_Y-4)
		Line 4,Fn_Y,27,Fn_Y
	Next
	UnlockBuffer TextureBuffer(SkalaTexture)
	EntityTexture SkalaEntity,SkalaTexture
	EntityFX SkalaEntity,3
	ScaleEntity SkalaEntity,Ini(GSize)*0.05,Ini(GSize)*0.8,1
	PositionEntity SkalaEntity,-Ini(GSize)*0.7,0,Ini(GSize)-2
	RotateEntity SkalaEntity,0,0,180
End Function

Function Sub_DeInit() ;just deletes everything that is still in Vidmem
	FreeEntity Cube
	FreeTexture CubeTexture
	FreeEntity SingleSurfEntity
	FreeTexture SingleSurfTexture
	FreeEntity Pivot
	FreeEntity Shadow
	FreeTexture ShadowTexture
	FreeEntity Background
	FreeTexture BackgroundTexture
End Function

Function Sub_ReadIni() ;Simple Ini Support... Could be more, could be less, better this than nothing I suppose^^
	Local FileIn,LineIn$,Command$,EnableHighValues,OutOfContest,Fn_Str$
	If FileType("Holocron.ini")=1 Then
		FileIn=ReadFile("Holocron.ini")
		While Not Eof(FileIn)
			LineIn=" "+ReadLine(FileIn)
			LineIn=Lower(GetToken(LineIn,";",1))
			LineIn=Replace(Replace(LineIn," ",""),Chr(9),"")
			If Not Instr(LineIn,"=")=0
				Command=GetToken(LineIn,"=",1)
				If Command="cubesize" Then
					Ini(Size)=GetToken(LineIn,"=",2)
				ElseIf Command="elementspacing"
					Ini(Space)=GetToken(LineIn,"=",2)
				ElseIf Command="elementscale"
					Ini(Scale)=GetToken(LineIn,"=",2)
				ElseIf Command="fps"
					Ini(FPS)=GetToken(LineIn,"=",2)
				ElseIf Command="glowduration"
					Ini(GlowD)=GetToken(LineIn,"=",2)
				ElseIf Command="graphicssize"
					Ini(GSize)=GetToken(LineIn,"=",2)
				ElseIf Command="xposition"
					Fn_Str=GetToken(LineIn,"=",2)
					Select Fn_Str
						Case "left"
							XOrientation=0
						Case "mid"
							XOrientation=1
						Case "right"
							XOrientation=2
					End Select
				ElseIf Command="yposition"
					Fn_Str=GetToken(LineIn,"=",2)
					Select Fn_Str
						Case "bottom"
							YOrientation=0
						Case "mid"
							YOrientation=1
						Case "top"
							YOrientation=2
					End Select
				EndIf
			Else
				Command=LineIn
				If Command="enablehighvalues"
					EnableHighValues=1
				ElseIf Command="outofcontest"
					OutOfContest=1
				EndIf
			EndIf
		Wend
	EndIf
	CloseFile FileIn
	If Ini(Size)<2 Then
		RuntimeError "CubeSize may not be smaler than 2("+Ini(Size)+")!"
	ElseIf Ini(Size)>20 Then
		If EnableHighValues=0 Then
			RuntimeError "You set a very high CubeSize!"+Chr(13)+Chr(10)+"Doing so could cause errors. If you still want to proceed, type"+Chr(13)+Chr(10)+"       EnableHighValues"+Chr(13)+Chr(10)+"into the config file."
		EndIf
	EndIf
	If Ini(FPS)<20
		RuntimeError "FpS(Frames per Second) may not be smaler than 20!"
	ElseIf Ini(FPS)>100
		If EnableHighValues=0 Then
			RuntimeError "You set a very high FpS Value!"+Chr(13)+Chr(10)+"Doing so could cause errors. If you still want to proceed, type"+Chr(13)+Chr(10)+"       EnableHighValues"+Chr(13)+Chr(10)+"into the config file."
		EndIf
	EndIf
	If Ini(GlowD)<1 Then
		RuntimeError "GlowDuration may not be smaler than 1!"
	EndIf
	If Ini(GSize)<32 Then
		RuntimeError "GraphicsSize may not be smaler than 32!"
	ElseIf Ini(GSize)>400 Then 
		If OutOfContest=0 Then
			RuntimeError "GraphicsSize may not be biger then 400 during the BCC 29 Contest."+Chr(13)+Chr(10)+"If the Contest is over, type"+Chr(13)+Chr(10)+"       OutOfContest"+Chr(13)+Chr(10)+"into the config file."
		EndIf
	EndIf
End Function

Function Sub_Clip2Desktop() ;Complicated thing... Clips the Window to the Desktop
	api_ShowWindow(SystemProperty("AppHWND"),SW_HIDE)
	;api_SetWindowLong(SystemProperty("AppHWND"),GWL_EXSTYLE,api_GetWindowLong(SystemProperty("AppHWND"),GWL_EXSTYLE) Or WS_EX_TOOLWINDOW) ; Toolwindows don't have a Taskbarentry, however the Taskbarentry isn't displayed anyway :/
	Local Fn_DHwnd=api_GetDesktopWindow()
	Local Fn_dx,Fn_dy,Fn_HWND=SystemProperty("AppHWND")
	Local Fn_Style,Fn_Rect,Fn_X,Fn_Y
	api_SystemParametersInfo(SPI_GETWORKAREA,0,DeskRect.Api_Rect,0)
	;RuntimeError DeskRect\Top+" "+DeskRect\Left+" "+DeskRect\Right+" "+DeskRect\Bottom
	
	Graphics3D(Ini(GSize),Ini(GSize),0,2)
	
	Fn_dx=(GetWindowWidth(Fn_HWND)-GetClientWidth(Fn_HWND))/2 ;Small (left/right/bottom) Border of a Window
	Fn_dy=GetWindowHeight(Fn_HWND)-GetClientHeight(Fn_HWND)-Fn_dx;Big (Upper/Caption) Border of a Window
	
	Fn_Rect=api_CreateRectRgn(Fn_dx,Fn_dy,Ini(GSize),Ini(GSize)+Fn_dy) ;the Region of the Window
	api_SetWindowRgn(Fn_HWND,Fn_Rect,True)
	api_DeleteObject(Fn_Rect)
	
	Fn_Style=api_GetWindowLong(Fn_HWND,GWL_STYLE) ;making the Window to a Child of the DesktopWindow
	Fn_Style=Fn_Style Or WS_CHILD
	api_SetWindowLong(Fn_HWND,GWL_STYLE,Fn_Style)
	api_SetParent(Fn_HWND,Fn_DHwnd)
	api_SetWindowLong(Fn_HWND,GWL_HWNDPARENT,Fn_DHwnd)
	Select XOrientation
		Case 0
			Fn_X=DeskRect\Left-Fn_dx*2
		Case 1
			Fn_X=DeskRect\Right/2+DeskRect\Left-GetWindowWidth(Fn_HWND)/2+Fn_dx
		Case 2
			Fn_X=DeskRect\Right+DeskRect\Left-GetWindowWidth(Fn_HWND)+Fn_dx*2
	End Select
	
	Select YOrientation
		Case 0
			Fn_Y=DeskRect\Top+DeskRect\Bottom+Fn_dx-GetWindowHeight(Fn_HWND)
		Case 1
			Fn_Y=DeskRect\Top+DeskRect\Bottom/2+Fn_dx/2-GetWindowHeight(Fn_HWND)/2
		Case 2
			Fn_Y=DeskRect\Top-Fn_dy
	End Select
	
	api_SetWindowPos(Fn_HWND,HWND_TOPMOST,Fn_X,Fn_Y,0,0,SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_SHOWWINDOW) ;Placing the Window
	api_ShowWindow(SystemProperty("AppHWND"),SW_SHOW) ;Display it again, finished finally^^
End Function



Function CreateQuad() ;self-explanatory I hope
	Local Fn_Mesh,Fn_Surf,Fn_Vert[3]
	Fn_Mesh=CreateMesh()
	Fn_Surf=CreateSurface(Fn_Mesh)
	Fn_Vert[0]=AddVertex(Fn_Surf,-1,1,0,0,0)
	Fn_Vert[1]=AddVertex(Fn_Surf,1,1,0,1,0)
	Fn_Vert[2]=AddVertex(Fn_Surf,-1,-1,0,0,1)
	AddTriangle(Fn_Surf,Fn_Vert[0],Fn_Vert[2],Fn_Vert[1])
	Fn_Vert[0]=AddVertex(Fn_Surf,1,-1,0,1,1)
	AddTriangle(Fn_Surf,Fn_Vert[0],Fn_Vert[1],Fn_Vert[2])
	Return Fn_Mesh
End Function


;GetR/G/B ; the Color-Table...
;I have choosen Blue to be the Night-Color and Yellow as the Day-Color. I thought that would be logically since 12 o'clock th sun is on the highest point=yellow and blue because it is the 0 o'clock midnight color (dunno why^^).
;Furthermore I placed the Color Red and Green not in the middle of Yellow and Blue like...
;Green 6 o'clock ; Red 18 o'clock
;That is because it's a small step from 255,255,0 to 255,0,0 but a big from 255,0,0 to 0,0,255. See?
;So I came up with this:

;0/24 o'clock Blue(255,0,0) midnight=blue
;9 o'clock Green(0,255,0) because of a big step ; didn't wanted to use red so only green was left
;12 o'clock Yellow(255,255,0) Sun on the highest point
;15 o'clock Red(0,255,0) That's around the hottest time in germany so red xD
;19-21 o'clock Sunset-Purple Colors

;I thought of this beeing the most logical and easyest to remember configuration for the colors.
;Minutes and Seconds follow the same sheme.

Function GetR(Fn_TimeC,Fn_Time)
	If Fn_TimeC=C_Hour Then
		Fn_Time=Fn_Time Mod 24
	Else
		Fn_Time=Fn_Time Mod 60
		Fn_Time=Fn_Time/2.5
	EndIf
	If Fn_Time<9 Then
		Return 0
	ElseIf Fn_Time<21 And Fn_Time>11 Then
		Return 255
	Else
		Select Fn_Time
			Case 9
				Return 64
			Case 10 
				Return 128
			Case 11
				Return 192
			Case 21
				Return 192
			Case 22
				Return 128
			Case 23
				Return 64
		End Select
	EndIf
End Function

Function GetG(Fn_TimeC,Fn_Time)
	If Fn_TimeC=C_Hour Then
		Fn_Time=Fn_Time Mod 24
	Else
		Fn_Time=Fn_Time Mod 60
		Fn_Time=Fn_Time/2.5
	EndIf
	If Fn_Time>15 Or Fn_Time=0 Then
		Return 0
	ElseIf Fn_Time<13 And Fn_Time>3 Then
		Return 255
	Else
		Select Fn_Time
			Case 1
				Return 64
			Case 2 
				Return 128
			Case 3
				Return 192
			Case 13
				Return 192
			Case 14
				Return 128
			Case 15
				Return 64
		End Select
	EndIf
End Function

Function GetB(Fn_TimeC,Fn_Time)
	If Fn_TimeC=C_Hour Then
		Fn_Time=Fn_Time Mod 24
	Else
		Fn_Time=Fn_Time Mod 60
		Fn_Time=Fn_Time/2.5
	EndIf
	If Fn_Time<17 And Fn_Time>7 Then
		Return 0
	ElseIf Fn_Time<5 Or Fn_Time>19 Then
		Return 255
	Else
		Select Fn_Time
			Case 17
				Return 64
			Case 18 
				Return 128
			Case 19
				Return 192
			Case 5
				Return 192
			Case 6
				Return 128
			Case 7
				Return 64
		End Select
	EndIf
End Function



Function AddToSurface(Fn_Mesh, Fn_Surf,Fn_SingleSurfaceEntity,Fn_X,Fn_Y,Fn_Z) ;Adds Mesh to SinglesurficeEntity
	;Copied from here: http://www.blitzforum.de/forum/viewtopic.php?t=20181
	;slightly edited to fit own needs :)
	Local Fn_Vert[2],Fn_I,Fn_S,Fn_I2,Fn_OldVert,Fn_Surface
	For Fn_S = 1 To CountSurfaces(Fn_Mesh)
		Fn_Surface = GetSurface(Fn_Mesh,Fn_S)      
		For Fn_I = 0 To  CountTriangles(Fn_Surface)-1
			For Fn_I2 = 0 To 2
				Fn_OldVert = TriangleVertex(Fn_Surface,Fn_I,Fn_I2)
				TFormPoint VertexX(Fn_Surface,Fn_OldVert),VertexY(Fn_Surface,Fn_OldVert),VertexZ(Fn_Surface,Fn_OldVert), Fn_Mesh,Fn_SingleSurfaceEntity
				Fn_Vert[Fn_I2] = AddVertex(Fn_Surf,TFormedX(),TFormedY(),TFormedZ(),VertexU(Fn_Surface,Fn_OldVert),VertexV(Fn_Surface,Fn_OldVert))
				VertexColor(Fn_Surf,Fn_Vert[Fn_I2],VertexRed(Fn_Surface,Fn_OldVert),VertexGreen(Fn_Surface,Fn_OldVert),VertexBlue(Fn_Surface,Fn_OldVert),VertexAlpha(Fn_Surface,Fn_OldVert))
			Next
			If Fn_I=0 Then	;I'm saving the Pivots in this Array to access it easier(just color changing)
				Cubes(Fn_X,Fn_Y,Fn_Z,0)=Fn_Vert[0]
				Cubes(Fn_X,Fn_Y,Fn_Z,1)=Fn_Vert[1]
				Cubes(Fn_X,Fn_Y,Fn_Z,2)=Fn_Vert[2]
			Else
				Cubes(Fn_X,Fn_Y,Fn_Z,3)=Fn_Vert[0]
			EndIf
			If Fn_I=0 Then
				AddTriangle(Fn_Surf, Fn_Vert[0], Fn_Vert[1], Fn_Vert[2])
			Else
				AddTriangle(Fn_Surf, Fn_Vert[0], Cubes(Fn_X,Fn_Y,Fn_Z,2), Cubes(Fn_X,Fn_Y,Fn_Z,1))
			EndIf
		Next
	Next
End Function

Function GetToken$( Fn_FullStr$, Fn_SplitChar$, Fn_TokNum% ) ;Gives back Parts of Strings. Big thx 2 Nox on Blitzforum.de!!
	;copied from here: http://www.blitzforum.de/forum/viewtopic.php?t=15242
	;really usefull Function! I'm using it in allmost every project!
	;(even though there is a bug. You have to be carefull if the Splitchar ist the first character. I just added a Space in front of it to avoid it
	;of course this is not a good way to get rid of that bug^^)
	Local Fn_CharPos% = 1, Fn_CurToken% = 0, Fn_TokenEnd%, Fn_TokenLen% = 0
	While( Fn_CharPos )
		Fn_CurToken=Fn_CurToken + 1 ; New token found, increase index.
		If(Fn_CurToken=Fn_TokNum) ; Reached wanted token.
			Fn_TokenEnd=Instr(Fn_FullStr,Fn_SplitChar,Fn_CharPos+1) ; Get end of token.
			If(Fn_TokenEnd=0)
				Fn_TokenEnd=Len(Fn_FullStr) ; If last token, end is last char.
				Fn_TokenLen=1 ; Not ending with split char, inc length.
			EndIf
			If(Fn_CurToken>1) Then ; Skip split character.
				Fn_CharPos=Fn_CharPos+1
			EndIf
			Fn_TokenLen=Fn_TokenLen+Fn_TokenEnd-Fn_CharPos ; Calculate length of token.
			Return Mid(Fn_FullStr,Fn_CharPos,Fn_TokenLen) ; Return token.
		EndIf
		Fn_CharPos=Instr(Fn_FullStr,Fn_SplitChar,Fn_CharPos+1)
	Wend
	Return "" ; Invalid token index/not found, return empty string.
End Function

Function CreateSegmentedCube(Fn_Segments) ;Outer-Cube... I segmented a Cube to be able to light it up just like the Inner-Cube so it would look like it is beeing lighted up by the inner
	Local Fn_X,Fn_Y,Fn_Mesh,Fn_Surf
	Local Fn_tmp#=2.0/(Fn_Segments-1)
	Fn_Mesh=CreateMesh()
	Fn_Surf=CreateSurface(Fn_Mesh)
	For Fn_X=0 To (Fn_Segments-1) ;I skip to comment this part. Actually its very confusing because I actually made a mistake with Indicating the Parts with X, Y and Z. I left the indications and fixed the Bugs by Trial-and-Error; Will write it new someday...
		For Fn_Y=0 To (Fn_Segments-1)
			;X=Z Y=Y
			OuterCube(Fn_X,Fn_Y,ZDown)=AddVertex(Fn_Surf,-1,Fn_Y*Fn_tmp-1,Fn_X*Fn_tmp-1,Fn_X*Fn_tmp/2,Fn_Y*Fn_tmp/2)
			VertexColor(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZDown),0,0,0)
			If Not Fn_X=0 Then
				If Fn_Y=0 Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZDown),OuterCube(Fn_X-1,Fn_Y+1,ZDown),OuterCube(Fn_X-1,Fn_Y,ZDown))
				ElseIf Fn_Y=(Fn_Segments-1) Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZDown),OuterCube(Fn_X-1,Fn_Y,ZDown),OuterCube(Fn_X,Fn_Y-1,ZDown))
				Else
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZDown),OuterCube(Fn_X-1,Fn_Y+1,ZDown),OuterCube(Fn_X-1,Fn_Y,ZDown))
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZDown),OuterCube(Fn_X-1,Fn_Y,ZDown),OuterCube(Fn_X,Fn_Y-1,ZDown))
				EndIf
			EndIf
			OuterCube(Fn_X,Fn_Y,ZUp)=AddVertex(Fn_Surf,1,Fn_Y*Fn_tmp-1,Fn_X*Fn_tmp-1,Fn_X*Fn_tmp/2,Fn_Y*Fn_tmp/2)
			VertexColor(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZUp),0,0,0)
			If Not Fn_X=0 Then
				If Fn_Y=0 Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZUp),OuterCube(Fn_X-1,Fn_Y,ZUp),OuterCube(Fn_X-1,Fn_Y+1,ZUp))
				ElseIf Fn_Y=(Fn_Segments-1) Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZUp),OuterCube(Fn_X,Fn_Y-1,ZUp),OuterCube(Fn_X-1,Fn_Y,ZUp))
				Else
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZUp),OuterCube(Fn_X-1,Fn_Y,ZUp),OuterCube(Fn_X-1,Fn_Y+1,ZUp))
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ZUp),OuterCube(Fn_X,Fn_Y-1,ZUp),OuterCube(Fn_X-1,Fn_Y,ZUp))
				EndIf
			EndIf
			
			;X=X Y=Z
			OuterCube(Fn_X,Fn_Y,XDown)=AddVertex(Fn_Surf,Fn_X*Fn_tmp-1,-1,Fn_Y*Fn_tmp-1,Fn_X*Fn_tmp/2,Fn_Y*Fn_tmp/2)
			VertexColor(Fn_Surf,OuterCube(Fn_X,Fn_Y,XDown),0,0,0)
			If Not Fn_X=0 Then
				If Fn_Y=0 Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,XDown),OuterCube(Fn_X-1,Fn_Y+1,XDown),OuterCube(Fn_X-1,Fn_Y,XDown))
				ElseIf Fn_Y=(Fn_Segments-1) Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,XDown),OuterCube(Fn_X-1,Fn_Y,XDown),OuterCube(Fn_X,Fn_Y-1,XDown))
				Else
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,XDown),OuterCube(Fn_X-1,Fn_Y+1,XDown),OuterCube(Fn_X-1,Fn_Y,XDown))
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,XDown),OuterCube(Fn_X-1,Fn_Y,XDown),OuterCube(Fn_X,Fn_Y-1,XDown))
				EndIf
			EndIf
			OuterCube(Fn_X,Fn_Y,XUp)=AddVertex(Fn_Surf,Fn_X*Fn_tmp-1,1,Fn_Y*Fn_tmp-1,Fn_X*Fn_tmp/2,Fn_Y*Fn_tmp/2)
			VertexColor(Fn_Surf,OuterCube(Fn_X,Fn_Y,XUp),0,0,0)
			If Not Fn_X=0 Then
				If Fn_Y=0 Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,XUp),OuterCube(Fn_X-1,Fn_Y,XUp),OuterCube(Fn_X-1,Fn_Y+1,XUp))
				ElseIf Fn_Y=(Fn_Segments-1) Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,XUp),OuterCube(Fn_X,Fn_Y-1,XUp),OuterCube(Fn_X-1,Fn_Y,XUp))
				Else
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,XUp),OuterCube(Fn_X-1,Fn_Y,XUp),OuterCube(Fn_X-1,Fn_Y+1,XUp))
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,XUp),OuterCube(Fn_X,Fn_Y-1,XUp),OuterCube(Fn_X-1,Fn_Y,XUp))
				EndIf
			EndIf
			
			;X=X Y=Y
			OuterCube(Fn_X,Fn_Y,YUp)=AddVertex(Fn_Surf,Fn_X*Fn_tmp-1,Fn_Y*Fn_tmp-1,1,Fn_X*Fn_tmp/2,Fn_Y*Fn_tmp/2)
			VertexColor(Fn_Surf,OuterCube(Fn_X,Fn_Y,YUp),0,0,0)
			If Not Fn_X=0 Then
				If Fn_Y=0 Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,YUp),OuterCube(Fn_X-1,Fn_Y+1,YUp),OuterCube(Fn_X-1,Fn_Y,YUp))
				ElseIf Fn_Y=(Fn_Segments-1) Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,YUp),OuterCube(Fn_X-1,Fn_Y,YUp),OuterCube(Fn_X,Fn_Y-1,YUp))
				Else
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,YUp),OuterCube(Fn_X-1,Fn_Y+1,YUp),OuterCube(Fn_X-1,Fn_Y,YUp))
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,YUp),OuterCube(Fn_X-1,Fn_Y,YUp),OuterCube(Fn_X,Fn_Y-1,YUp))
				EndIf
			EndIf
			OuterCube(Fn_X,Fn_Y,YDown)=AddVertex(Fn_Surf,Fn_X*Fn_tmp-1,Fn_Y*Fn_tmp-1,-1,Fn_X*Fn_tmp/2,Fn_Y*Fn_tmp/2)
			VertexColor(Fn_Surf,OuterCube(Fn_X,Fn_Y,YDown),0,0,0)
			If Not Fn_X=0 Then
				If Fn_Y=0 Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,YDown),OuterCube(Fn_X-1,Fn_Y,YDown),OuterCube(Fn_X-1,Fn_Y+1,YDown))
				ElseIf Fn_Y=(Fn_Segments-1) Then
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,YDown),OuterCube(Fn_X,Fn_Y-1,YDown),OuterCube(Fn_X-1,Fn_Y,YDown))
				Else
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,YDown),OuterCube(Fn_X-1,Fn_Y,YDown),OuterCube(Fn_X-1,Fn_Y+1,YDown))
					AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,YDown),OuterCube(Fn_X,Fn_Y-1,YDown),OuterCube(Fn_X-1,Fn_Y,YDown))
				EndIf
			EndIf
		Next
	Next
	Return Fn_Mesh
End Function

Function CreateSegmentedPlane(Fn_SegmentsX,Fn_SegmentsY,Fn_State)
	Local Fn_X,Fn_Y,Fn_Z,Fn_Mesh,Fn_Surf
	Local Fn_Xtmp#=2.0/(Fn_SegmentsX-1)
	Local Fn_Ytmp#=2.0/(Fn_SegmentsY-1)
	Fn_Mesh=CreateMesh()
	Fn_Surf=CreateSurface(Fn_Mesh)
	For Fn_X=0 To (Fn_SegmentsX-1) ;I skip to comment this part. Actually its very confusing because I actually made a mistake with Indicating the Parts with X, Y and Z. I left the indications and fixed the Bugs by Trial-and-Error; Will write it new someday...
		For Fn_Y=0 To (Fn_SegmentsY-1)
			;X=Z Y=Y
			If Fn_State=1 Then
				OuterCube(Fn_X,Fn_Y,ShadowPlane)=AddVertex(Fn_Surf,Fn_X*Fn_Xtmp-1,Fn_Y*Fn_Ytmp-1,0,Fn_X*Fn_Xtmp/2,Fn_Y*Fn_Ytmp/2)
				VertexColor(Fn_Surf,OuterCube(Fn_X,Fn_Y,ShadowPlane),0,0,0)
				If Not Fn_X=0 Then
					If Fn_Y=0 Then
						AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ShadowPlane),OuterCube(Fn_X-1,Fn_Y+1,ShadowPlane),OuterCube(Fn_X-1,Fn_Y,ShadowPlane))
					ElseIf Fn_Y=(Fn_SegmentsY-1) Then
						AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ShadowPlane),OuterCube(Fn_X-1,Fn_Y,ShadowPlane),OuterCube(Fn_X,Fn_Y-1,ShadowPlane))
					Else
						AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ShadowPlane),OuterCube(Fn_X-1,Fn_Y+1,ShadowPlane),OuterCube(Fn_X-1,Fn_Y,ShadowPlane))
						AddTriangle(Fn_Surf,OuterCube(Fn_X,Fn_Y,ShadowPlane),OuterCube(Fn_X-1,Fn_Y,ShadowPlane),OuterCube(Fn_X,Fn_Y-1,ShadowPlane))
					EndIf
				EndIf
			ElseIf Fn_State=2
				Skala(Fn_X,Fn_Y)=AddVertex(Fn_Surf,Fn_X*Fn_Xtmp-1,Fn_Y*Fn_Ytmp-1,0,Fn_X*Fn_Xtmp/2,Fn_Y*Fn_Ytmp/2)
				If Fn_X=0 Or Fn_X=(Fn_SegmentsX-1) Then
					VertexColor(Fn_Surf,Skala(Fn_X,Fn_Y),0,0,0)
				Else
					VertexColor(Fn_Surf,Skala(Fn_X,Fn_Y),128,128,128)
				EndIf
				If Not Fn_X=0 Then
					If Fn_Y=0 Then
						AddTriangle(Fn_Surf,Skala(Fn_X,Fn_Y),Skala(Fn_X-1,Fn_Y+1),Skala(Fn_X-1,Fn_Y))
					ElseIf Fn_Y=(Fn_SegmentsY-1) Then
						AddTriangle(Fn_Surf,Skala(Fn_X,Fn_Y),Skala(Fn_X-1,Fn_Y),Skala(Fn_X,Fn_Y-1))
					Else
						AddTriangle(Fn_Surf,Skala(Fn_X,Fn_Y),Skala(Fn_X-1,Fn_Y+1),Skala(Fn_X-1,Fn_Y))
						AddTriangle(Fn_Surf,Skala(Fn_X,Fn_Y),Skala(Fn_X-1,Fn_Y),Skala(Fn_X,Fn_Y-1))
					EndIf
				EndIf
			EndIf
		Next
	Next
	Return Fn_Mesh
End Function

Function GetEntry$(Fn_Path$, Fn_Entry$) ;Gets a Registry-Entry
	;I've got this one from here: http://www.blitzforum.de/forum/viewtopic.php?t=18055 thanx 2 Willi die Rbe, the Pop-Up Boxes at startup, however, are annoying as hell :/
	Local Fn_tmp1$,Fn_tmp2%,Fn_tmp3%,Fn_tmp4%,Fn_tmp5$
	Local Fn_File2,Fn_File,Fn_tmp6$
	Fn_File2=WriteFile("tmp.bat")
	WriteLine Fn_File2, "REG QUERY "+Chr(34)+Fn_Path$+Chr(34)+" /v "+Chr(34)+Fn_Entry$+Chr(34)+">tmp2"
	CloseFile Fn_File2 
	ExecFile("tmp.bat")
	Delay 200
	Fn_File=ReadFile("tmp2")
	While Eof(Fn_File)=0
		Fn_tmp1$=ReadLine$(Fn_File)
		Fn_tmp2%=Instr(Fn_tmp1$, Fn_Entry$)
		If Fn_tmp2%>0
			Fn_tmp3=Instr(Fn_tmp1$,"REG_",Fn_tmp2%)
			If Fn_tmp3>0
				Fn_tmp4%=Instr(Fn_tmp1$, Chr$(9),Fn_tmp3%)
				If Fn_tmp4%>0 Then
					Fn_tmp5$=Mid(Fn_tmp1$,Fn_tmp4%+1)
					Fn_tmp6$=GetEntryType(Fn_Path$,Fn_Entry$)
					If Fn_tmp6$="REG_DWORD" And Instr(Fn_tmp5$, "0x")>0 Then Fn_tmp5$=Right(Fn_tmp5$, Len(Fn_tmp5$)-2) : Fn_tmp5$= "$"+Fn_tmp5$
					CloseFile Fn_File
					DeleteFile("tmp.bat")
					DeleteFile("tmp2")
					Return Fn_tmp5$       
				EndIf
			EndIf
		EndIf
	Wend
End Function

Function GetEntryType$(Fn_Path$, Fn_Entry$) ;See GetEntry-Function
	Local Fn_tmp1$,Fn_tmp2%,Fn_tmp3%,Fn_tmp4%,Fn_tmp5$
	Local Fn_File,Fn_File2
	Fn_File2=WriteFile("tmp.bat")
	WriteLine Fn_File2, "REG QUERY "+Chr(34)+Fn_Path$+Chr(34)+" /v "+Chr(34)+Fn_Entry$+Chr(34)+">tmp2"
	CloseFile Fn_File2 
	ExecFile("tmp.bat")
	Delay 200
	Fn_File=ReadFile("tmp2")
	While Eof(Fn_File)=0
		Fn_tmp1$=ReadLine$(Fn_File)
		Fn_tmp2%=Instr(Fn_tmp1$, Fn_Entry$)
		If Fn_tmp2%>0
			Fn_tmp3=Instr(Fn_tmp1$,"REG_",Fn_tmp2%)
			If Fn_tmp3>0
				Fn_tmp4%=Instr(Fn_tmp1$, Chr$(9),Fn_tmp3%)
				If Fn_tmp4%>0 Then
					Fn_tmp5$=Mid(Fn_tmp1$,Fn_tmp3%, Fn_tmp4%-Fn_tmp3)
					CloseFile Fn_File
					DeleteFile("tmp3.bat")
					DeleteFile("tmp4")
					Return Fn_tmp5$
					
				EndIf
			EndIf
		EndIf
	Wend
End Function 

Function GetWindowWidth(Fn_HWND) ; These four are WindowsApi Wrapper for getting the Size of Windows like Desktop or getting the Size of the Window-Borders wich could vary from pc 2 pc
	Local Fn_Ret,Fn_Rect=CreateBank(16)
	api_GetWindowRect(Fn_HWND,Fn_Rect)
	Fn_Ret=PeekInt(Fn_Rect,8)-PeekInt(Fn_Rect,0)
	FreeBank Fn_Rect
	Return Fn_Ret
End Function

Function GetWindowHeight(Fn_HWND)
	Local Fn_Ret,Fn_Rect=CreateBank(16)
	api_GetWindowRect(Fn_HWND,Fn_Rect)
	Fn_Ret=PeekInt(Fn_Rect,12)-PeekInt(Fn_Rect,4)
	FreeBank Fn_Rect
	Return Fn_Ret
End Function

Function GetClientWidth(Fn_HWND)
	Local Fn_Ret,Fn_Rect=CreateBank(16)
	api_GetClientRect(Fn_HWND,Fn_Rect)
	Fn_Ret=PeekInt(Fn_Rect,8)
	FreeBank Fn_Rect
	Return Fn_Ret
End Function

Function GetClientHeight(Fn_HWND)
	Local Fn_Ret,Fn_Rect=CreateBank(16)
	api_GetClientRect(Fn_HWND,Fn_Rect)
	Fn_Ret=PeekInt(Fn_Rect,12)
	FreeBank Fn_Rect
	Return Fn_Ret
End Function

Function IsKeyPressed( vKey% ) ;Check if  a key is pressed - while not beeing in the Blitz Window
	;This last one is a copy from here: http://www.blitzforum.de/forum/viewtopic.php?t=25071
	;needs Virtual-Key-Codes! Neither Scan- nor Ascii-Codes will work! Google for them, you'll find them :)
	Return ( api_GetAsyncKeyState( vKey ) Shr 16 ) And 1
End Function 

Function PaintDesktop(hdc)
	Return api_PaintDesktop(hdc)
End Function

Function RelocateWindow()
	Local Fn_dx,Fn_dy,Fn_HWND=SystemProperty("AppHWND")
	Local Fn_X,Fn_Y,Fn_hdc,Fn_PD
	Local Fn_R,Fn_G,Fn_B,Fn_BGR
	
	Fn_dx=(GetWindowWidth(Fn_HWND)-GetClientWidth(Fn_HWND))/2 ;Small (left/right/bottom) Border of a Window
	Fn_dy=GetWindowHeight(Fn_HWND)-GetClientHeight(Fn_HWND)-Fn_dx;Big (Upper/Caption) Border of a Window
	
	Select XOrientation
		Case 0
			Fn_X=DeskRect\Left-Fn_dx*2
		Case 1
			Fn_X=DeskRect\Right/2+DeskRect\Left-GetWindowWidth(Fn_HWND)/2+Fn_dx
		Case 2
			Fn_X=DeskRect\Right+DeskRect\Left-GetWindowWidth(Fn_HWND)+Fn_dx*2
	End Select
	
	Select YOrientation
		Case 0
			Fn_Y=DeskRect\Top+DeskRect\Bottom+Fn_dx-GetWindowHeight(Fn_HWND)
		Case 1
			Fn_Y=DeskRect\Top+DeskRect\Bottom/2+Fn_dx/2-GetWindowHeight(Fn_HWND)/2
		Case 2
			Fn_Y=DeskRect\Top-Fn_dy
	End Select
	
	api_SetWindowPos(Fn_HWND,HWND_TOPMOST,Fn_X,Fn_Y,0,0,SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_SHOWWINDOW) ;Placing the Window
	Fn_hdc=api_GetDC(SystemProperty("AppHWND"))
	Fn_PD=PaintDesktop(Fn_hdc)
	If Not Fn_PD=0 Then
		SetBuffer TextureBuffer(BackgroundTexture)
		ClsColor 255,0,255
		Cls
		LockBuffer TextureBuffer(BackgroundTexture)
		Delay 1000
		For Fn_X=0 To (Ini(GSize)-1)
			PaintDesktop(Fn_hdc)
			;Delay 10
			For Fn_Y=0 To (Ini(GSize)-1)
				
				Fn_BGR=api_GetPixel(Fn_hdc,Fn_X,Fn_Y)
				Fn_R=Fn_BGR And  $0000FF
				Fn_G=(Fn_BGR And $00FF00)/$100
				Fn_B=(Fn_BGR And $FF0000)/$10000
				WritePixelFast(Fn_X,Fn_Y,Fn_R*$10000+Fn_G*$100+Fn_B,TextureBuffer(BackgroundTexture))
			Next
		Next
		UnlockBuffer TextureBuffer(BackgroundTexture)
		SetBuffer BackBuffer()
	EndIf
	api_SetWindowPos(SystemProperty("AppHWND"),HWND_BOTTOM,0,0,0,0,SWP_NOSIZE Or SWP_NOMOVE Or SWP_NOACTIVATE Or SWP_SHOWWINDOW)
	
End Function

;~IDEal Editor Parameters:
;~F#1D#4B#17D#1F3#1FF#24F#27E#29C#2B9#2D6#2F5#312#32B#384#3B1#3D0#3ED#3F5#3FD#405
;~F#40D#413#417
;~C#Blitz3D